//=============================================================================
//
// file :        Libera.h
//
// description : Include for the Libera class.
//
// project :	Libera BPM Device Server
//
// $Author: nleclercq $
//
// copyleft :    European Synchrotron Radiation Facility
//               BP 220, Grenoble 38043
//               FRANCE
//
//=============================================================================
//
//      This file is generated by POGO
//  (Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
#ifndef _LIBERA_H
#define _LIBERA_H

#include <tango.h>
#include "BPM.h"
#include "DynamicAttr.h"
#include "DynamicAttrHelper.h"
#include "InnerAppender.h"

using namespace bpm;

//using namespace Tango;

/**
 * @author	$Author: nleclercq $
 * @version	$Revision: 1.5.2.27.2.1 $
 */

// Add your own constants definitions here.
//-----------------------------------------------
#define kILK_NUM_PARAMS 8

namespace Libera_ns
{

/**
 * Class Description:
 * IT Libera BPM Device Server
 */

/*
 *	Device States Description:
*  Tango::UNKNOWN :  Device is not [or not properly] initialized
*  Tango::FAULT :    Device initialization failed or unrecoverable error
*  Tango::ON :       BPM is up and running
 */


class Libera: public Tango::Device_4Impl
{
public:
  //  Add your own data members here
  //-----------------------------------------

  //  Here is the Start of the automatic code generation part
  //-------------------------------------------------------------
  /**
   *	@name attributes
   *	Attributs member data.
   */
/*
//@{
		Tango::DevUShort	*attr_LiberaModel_read;
		Tango::DevBoolean	*attr_DDEnabled_read;
		Tango::DevBoolean	attr_DDEnabled_write;
		Tango::DevLong	*attr_DDBufferSize_read;
		Tango::DevLong	attr_DDBufferSize_write;
		Tango::DevUShort	*attr_DDDecimationFactor_read;
		Tango::DevUShort	attr_DDDecimationFactor_write;
		Tango::DevLong	*attr_DDTriggerOffset_read;
		Tango::DevLong	attr_DDTriggerOffset_write;
		Tango::DevBoolean	*attr_DDBufferFreezingEnabled_read;
		Tango::DevBoolean	*attr_DDBufferFrozen_read;
		Tango::DevLong	*attr_DDTriggerCounter_read;
		Tango::DevBoolean	*attr_ExternalTriggerEnabled_read;
		Tango::DevLong	*attr_ExternalTriggerDelay_read;
		Tango::DevLong	attr_ExternalTriggerDelay_write;
		Tango::DevBoolean	*attr_SAEnabled_read;
		Tango::DevBoolean	attr_SAEnabled_write;
		Tango::DevDouble	*attr_VaSA_read;
		Tango::DevDouble	*attr_VbSA_read;
		Tango::DevDouble	*attr_VcSA_read;
		Tango::DevDouble	*attr_VdSA_read;
		Tango::DevDouble	*attr_XPosSA_read;
		Tango::DevDouble	*attr_ZPosSA_read;
		Tango::DevDouble	*attr_SumSA_read;
		Tango::DevDouble	*attr_QuadSA_read;
		Tango::DevLong	*attr_CxSA_read;
		Tango::DevLong	*attr_CzSA_read;
		Tango::DevLong	*attr_SAStatNumSamples_read;
		Tango::DevLong	attr_SAStatNumSamples_write;
		Tango::DevDouble	*attr_XMeanPosSA_read;
		Tango::DevDouble	*attr_ZMeanPosSA_read;
		Tango::DevDouble	*attr_XRMSPosSA_read;
		Tango::DevDouble	*attr_ZRMSPosSA_read;
		Tango::DevDouble	*attr_XPeakPosSA_read;
		Tango::DevDouble	*attr_ZPeakPosSA_read;
		Tango::DevDouble	*attr_SumMeanSA_read;
		Tango::DevBoolean	*attr_ADCEnabled_read;
		Tango::DevBoolean	attr_ADCEnabled_write;
		Tango::DevLong	*attr_ADCBufferSize_read;
		Tango::DevLong	attr_ADCBufferSize_write;
		Tango::DevLong	*attr_PMOffset_read;
		Tango::DevLong	attr_PMOffset_write;
		Tango::DevBoolean	*attr_PMNotified_read;
		Tango::DevShort	*attr_PMNotificationCounter_read;
		Tango::DevBoolean	*attr_InterlockXNotified_read;
		Tango::DevBoolean	*attr_InterlockZNotified_read;
		Tango::DevBoolean	*attr_InterlockAttnNotified_read;
		Tango::DevBoolean	*attr_InterlockADCPreFilterNotified_read;
		Tango::DevBoolean	*attr_InterlockADCPostFilterNotified_read;
		Tango::DevDouble	*attr_XLow_read;
		Tango::DevDouble	*attr_XHigh_read;
		Tango::DevDouble	*attr_ZLow_read;
		Tango::DevDouble	*attr_ZHigh_read;
		Tango::DevBoolean	*attr_AutoSwitchingEnabled_read;
		Tango::DevShort	*attr_Switches_read;
		Tango::DevShort	attr_Switches_write;
		Tango::DevBoolean	*attr_ExternalSwitching_read;
		Tango::DevBoolean	attr_ExternalSwitching_write;
		Tango::DevLong	*attr_SwitchingDelay_read;
		Tango::DevLong	attr_SwitchingDelay_write;
		Tango::DevLong	*attr_OffsetTune_read;
		Tango::DevLong	attr_OffsetTune_write;
		Tango::DevBoolean	*attr_CompensateTune_read;
		Tango::DevBoolean	attr_CompensateTune_write;
		Tango::DevShort	*attr_DSCMode_read;
		Tango::DevShort	attr_DSCMode_write;
		Tango::DevBoolean	*attr_AGCEnabled_read;
		Tango::DevBoolean	attr_AGCEnabled_write;
		Tango::DevDouble	*attr_Gain_read;
		Tango::DevDouble	attr_Gain_write;
		Tango::DevBoolean	*attr_HasMAFSupport_read;
		Tango::DevLong	*attr_MAFLength_read;
		Tango::DevLong	attr_MAFLength_write;
		Tango::DevLong	*attr_MAFDelay_read;
		Tango::DevLong	attr_MAFDelay_write;
		Tango::DevDouble	*attr_MachineTime_read;
		Tango::DevDouble	attr_MachineTime_write;
		Tango::DevLong	*attr_TimePhase_read;
		Tango::DevLong	attr_TimePhase_write;
		Tango::DevDouble	*attr_SystemTime_read;
		Tango::DevDouble	attr_SystemTime_write;
		Tango::DevBoolean	*attr_SCPLLStatus_read;
		Tango::DevBoolean	*attr_MCPLLStatus_read;
		Tango::DevShort	*attr_HWTemperature_read;
		Tango::DevShort	*attr_Fan1Speed_read;
		Tango::DevShort	*attr_Fan2Speed_read;
		Tango::DevDouble	*attr_Incoherence_read;
		Tango::DevDouble	*attr_RefIncoherence_read;
		Tango::DevDouble	*attr_MaxIncoherence_read;
		Tango::DevDouble	attr_MaxIncoherence_write;
		Tango::DevDouble	*attr_MaxIncoherenceDrift_read;
		Tango::DevDouble	attr_MaxIncoherenceDrift_write;
		Tango::DevLong	*attr_UpTime_read;
		Tango::DevLong	*attr_CpuUsage_read;
		Tango::DevLong	*attr_FreeMemory_read;
		Tango::DevLong	*attr_RamFsUsage_read;
		Tango::DevBoolean	*attr_UseLiberaSAData_read;
		Tango::DevBoolean	attr_UseLiberaSAData_write;
		Tango::DevDouble	*attr_XPosDD_read;
		Tango::DevDouble	*attr_ZPosDD_read;
		Tango::DevDouble	*attr_QuadDD_read;
		Tango::DevDouble	*attr_SumDD_read;
		Tango::DevDouble	*attr_VaDD_read;
		Tango::DevDouble	*attr_VbDD_read;
		Tango::DevDouble	*attr_VcDD_read;
		Tango::DevDouble	*attr_VdDD_read;
		Tango::DevDouble	*attr_XPosSAHistory_read;
		Tango::DevDouble	*attr_ZPosSAHistory_read;
		Tango::DevDouble	*attr_SumSAHistory_read;
		Tango::DevDouble	*attr_XPosPM_read;
		Tango::DevDouble	*attr_ZPosPM_read;
		Tango::DevDouble	*attr_QuadPM_read;
		Tango::DevDouble	*attr_SumPM_read;
		Tango::DevDouble	*attr_VaPM_read;
		Tango::DevDouble	*attr_VbPM_read;
		Tango::DevDouble	*attr_VcPM_read;
		Tango::DevDouble	*attr_VdPM_read;
		Tango::DevShort	*attr_ADCChannelA_read;
		Tango::DevShort	*attr_ADCChannelB_read;
		Tango::DevShort	*attr_ADCChannelC_read;
		Tango::DevShort	*attr_ADCChannelD_read;
		Tango::DevDouble	*attr_IaDD_read;
		Tango::DevDouble	*attr_IbDD_read;
		Tango::DevDouble	*attr_IcDD_read;
		Tango::DevDouble	*attr_IdDD_read;
		Tango::DevDouble	*attr_QaDD_read;
		Tango::DevDouble	*attr_QbDD_read;
		Tango::DevDouble	*attr_QcDD_read;
		Tango::DevDouble	*attr_QdDD_read;
		Tango::DevShort	*attr_UserData_read;
		Tango::DevDouble	*attr_InterlockConfiguration_read;
		Tango::DevString	*attr_logs_read;
//@}
*/
  /*
   *	@name Device properties
   *	Device properties member data.
   */
  //@{
/**
 *	The Libera IP address [no default value]
 */
	string	liberaIpAddr;
/**
 *	The port on which the generic server handles external requests. Defaults to 23721.
 */
	Tango::DevShort	liberaPort;
/**
 *	Default [or initial] value for attribute DDBufferSize [in samples]. Defaults to 1024.
 */
	Tango::DevLong	defaultDDBufferSize;
/**
 *	Switches configuration. The valid range is [0..15]. Defaults to 3.
 */
	Tango::DevShort	switches;
/**
 *	Asynch. notifications (e.g. trigger events) will be send to this addr [no default value]
 */
	string	liberaMulticastIpAddr;
/**
 *	The BPM location [TL1, BOOSTER, TL2 or STORAGE_RING]. No default value.
 */
	string	location;
/**
 *	Enables (or not) the external trigger source.
 *	Inlfuences the TANGO device behaviour not the Libera itself. Defaults to false.
 */
	Tango::DevBoolean	enableExternalTrigger;
/**
 *	Specify the watch-dog (1) or data reading period (2) in ms.
 *	Must be in the rangec [500, 25000] ms. Defaults to 1000.
 *	(1) : external trigger enabled - (2) : external trigger disabled.
 */
	Tango::DevULong	dDTaskActivityPeriod;
/**
 *	Specify the watch-dog (1) or data reading period (2) in ms.
 *	Must be in the range [100, 25000] ms. Defaults to 100.
 */
	Tango::DevULong	sATaskActivityPeriod;
/**
 *	Specifies whether or not the DD data source should be enabled at startup. Defaults to false.
 */
	Tango::DevBoolean	enableDD;
/**
 *	Specifies whether or not the SA data source should be enabled at startup. Defaults to false.
 */
	Tango::DevBoolean	enableSA;
/**
 *	SA history buffer length [in samples]. Defaults to 8196.
 */
	Tango::DevULong	sAHistoryLength;
/**
 *	The DD decimation factor.
 *	Allowed values : 1 (no decimation) or 64 (for the so called booster normal mode)
 */
	Tango::DevUShort	dDDecimationFactor;
/**
 *	When set to TRUE, auto-switching is automattically enabled when the SA data source is itself enabled
 */
	Tango::DevBoolean	enableAutoSwitchingIfSAEnabled;
/**
 *	When set to TRUE, the Digital Signal Conditioning is automattically enabled when the auto-switching is itself enabled
 */
	Tango::DevBoolean	enableDSCIfAutoSwitchingEnabled;
/**
 *	Default number of SA history samples to use form RMS pos. computation.
 *	Defaults to 10 (last second in the SA history).
 */
	Tango::DevULong	defaultSAStatNumSamples;
/**
 *	Default [or initial] value for attribute ADCBufferSize [in samples]. Defaults to 1024.
 */
	Tango::DevLong	defaultADCBufferSize;
/**
 *	Specifies the data reading period in ms.
 *	Must be in the range [500, 25000] ms. Defaults to 1000.
 *	
 */
	Tango::DevULong	aDCTaskActivityPeriod;
/**
 *	Specifies whether or not the ADC data source should be enabled at startup. Defaults to false.
 */
	Tango::DevBoolean	enableADC;
/**
 *	Default value for the machine time phase. Its valid range is [0, RfSfRatio - 1] where
 *	RfSfRatio is a machine dependent system property.
 */
	Tango::DevLong	defaultTimePhaseValue;
/**
 *	The user defined interlock configuration. This is the configuration that should be applied on the Libera in case the device 'finds'
 *	the Libera in its default startup configuration when it is itself starting up or executing its Init TANGO command. This configuration
 *	can also be applied using the dedicated 'SetInterlockConfiguration' expert command.
 *	Parameters mapping:
 *	[0] Interlock : mode - [0]: disabled, [1]: enabled, [3]: enabled with gain dependency
 *	[1] Interlock : threshold : X low in mm
 *	[2] Interlock : threshold : X high in mm
 *	[3] Interlock : threshold : Z low in mm (i.e. Y low in the Libera terminology)
 *	[4] Interlock : threshold : Z high in mm (i.e. Y high in the Libera terminology)
 *	[5] Interlock : overflow limit (ADC threshold)
 *	[6] Interlock : overflow duration (num of overloaded ADC samples before raising intlck)
 *	[7] Interlock : gain limit in dBm  (intlck not active under this limit) - valid range is [-60, 0]
 */
	vector<FPDataType>	interlockConfiguration;
/**
 *	Enables/Disables  DD optional data (IxDD and QxDD)
 */
	Tango::DevBoolean	enableDDOptionalData;
/**
 *	Enables/disables SA optional Data (currently not used)
 */
	Tango::DevBoolean	enableSAOptionalData;
/**
 *	Enables/disables SA History optional data (sum history)
 */
	Tango::DevBoolean	enableSAHistoryOptionalData;
/**
 *	Enables/disables ADC optional data (currently not used)
 */
	Tango::DevBoolean	enableADCOptionalData;
/**
 *	0: TANGO_INSTITUTE (GENERIC)
 *	1: ALBA
 *	2: ESRF
 *	3: ELETTRA
 *	4: SOLEIL
 */
	Tango::DevShort	institute;
/**
 *	Max. DD buffer size when decimation enabled on DD data source.
 *	Defaults to 10000
 */
	Tango::DevLong	maxDDBufferSizeWhenDecimationEnabled;
/**
 *	Controls wether or not the BBA offsets are taken into account when computing the offsets passed to the FPGA process
 */
	Tango::DevBoolean	passBBAOffsetsToFPGA;
/**
 *	The <FA Data> cache refresh period in msecs.
 *	Defaults to 500 ms (2Hz).
 */
	Tango::DevULong	fADataCacheRefreshPeriod;
//@}

  /**@name Constructors
   * Miscellaneous constructors */
  //@{
  /**
   * Constructs a newly allocated Command object.
   *
   *	@param cl	Class.
   *	@param s 	Device Name
   */
  Libera (Tango::DeviceClass * cl, string & s);

  /**
   * Constructs a newly allocated Command object.
   *
   *	@param cl	Class.
   *	@param s 	Device Name
   */
  Libera (Tango::DeviceClass * cl, const char *s);

  /**
   * Constructs a newly allocated Command object.
   *
   *	@param cl	Class.
   *	@param s 	Device name
   *	@param d	Device description.
   */
  Libera (Tango::DeviceClass * cl, const char *s, const char *d);

  //@}

  /**@name Destructor
   * Only one desctructor is defined for this class */
  //@{
  /**
   * The object desctructor.
   */
  virtual ~ Libera ()
  {
    delete_device ();
  };

  /**
   *	will be called at device destruction or at init command.
   */
  void delete_device ();

  //@}

  /**@name Miscellaneous methods */
  //@{
  /**
   *	Initialize the device
   */
  virtual void init_device ();

  /**
   *	Always executed method befor execution command method.
   */
  virtual void always_executed_hook ();

//@}

/**
 * @name Libera methods prototypes
 */

//@{
/**
 *	Hardware acquisition for attributes.
 */
	virtual void read_attr_hardware(vector<long> &attr_list);
/**
 *	Extract real attribute values for LiberaModel acquisition result.
 */
	virtual void read_LiberaModel(Tango::Attribute &attr);
/**
 *	Extract real attribute values for DDEnabled acquisition result.
 */
	virtual void read_DDEnabled(Tango::Attribute &attr);
/**
 *	Write DDEnabled attribute values to hardware.
 */
	virtual void write_DDEnabled(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for DDBufferSize acquisition result.
 */
	virtual void read_DDBufferSize(Tango::Attribute &attr);
/**
 *	Write DDBufferSize attribute values to hardware.
 */
	virtual void write_DDBufferSize(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for DDDecimationFactor acquisition result.
 */
	virtual void read_DDDecimationFactor(Tango::Attribute &attr);
/**
 *	Write DDDecimationFactor attribute values to hardware.
 */
	virtual void write_DDDecimationFactor(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for DDTriggerOffset acquisition result.
 */
	virtual void read_DDTriggerOffset(Tango::Attribute &attr);
/**
 *	Write DDTriggerOffset attribute values to hardware.
 */
	virtual void write_DDTriggerOffset(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for DDBufferFreezingEnabled acquisition result.
 */
	virtual void read_DDBufferFreezingEnabled(Tango::Attribute &attr);
/**
 *	Extract real attribute values for DDBufferFrozen acquisition result.
 */
	virtual void read_DDBufferFrozen(Tango::Attribute &attr);
/**
 *	Extract real attribute values for DDTriggerCounter acquisition result.
 */
	virtual void read_DDTriggerCounter(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ExternalTriggerEnabled acquisition result.
 */
	virtual void read_ExternalTriggerEnabled(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ExternalTriggerDelay acquisition result.
 */
	virtual void read_ExternalTriggerDelay(Tango::Attribute &attr);
/**
 *	Write ExternalTriggerDelay attribute values to hardware.
 */
	virtual void write_ExternalTriggerDelay(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for SAEnabled acquisition result.
 */
	virtual void read_SAEnabled(Tango::Attribute &attr);
/**
 *	Write SAEnabled attribute values to hardware.
 */
	virtual void write_SAEnabled(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for VaSA acquisition result.
 */
	virtual void read_VaSA(Tango::Attribute &attr);
/**
 *	Extract real attribute values for VbSA acquisition result.
 */
	virtual void read_VbSA(Tango::Attribute &attr);
/**
 *	Extract real attribute values for VcSA acquisition result.
 */
	virtual void read_VcSA(Tango::Attribute &attr);
/**
 *	Extract real attribute values for VdSA acquisition result.
 */
	virtual void read_VdSA(Tango::Attribute &attr);
/**
 *	Extract real attribute values for XPosSA acquisition result.
 */
	virtual void read_XPosSA(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ZPosSA acquisition result.
 */
	virtual void read_ZPosSA(Tango::Attribute &attr);
/**
 *	Extract real attribute values for SumSA acquisition result.
 */
	virtual void read_SumSA(Tango::Attribute &attr);
/**
 *	Extract real attribute values for QuadSA acquisition result.
 */
	virtual void read_QuadSA(Tango::Attribute &attr);
/**
 *	Extract real attribute values for CxSA acquisition result.
 */
	virtual void read_CxSA(Tango::Attribute &attr);
/**
 *	Extract real attribute values for CzSA acquisition result.
 */
	virtual void read_CzSA(Tango::Attribute &attr);
/**
 *	Extract real attribute values for SAStatNumSamples acquisition result.
 */
	virtual void read_SAStatNumSamples(Tango::Attribute &attr);
/**
 *	Write SAStatNumSamples attribute values to hardware.
 */
	virtual void write_SAStatNumSamples(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for XMeanPosSA acquisition result.
 */
	virtual void read_XMeanPosSA(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ZMeanPosSA acquisition result.
 */
	virtual void read_ZMeanPosSA(Tango::Attribute &attr);
/**
 *	Extract real attribute values for XRMSPosSA acquisition result.
 */
	virtual void read_XRMSPosSA(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ZRMSPosSA acquisition result.
 */
	virtual void read_ZRMSPosSA(Tango::Attribute &attr);
/**
 *	Extract real attribute values for XPeakPosSA acquisition result.
 */
	virtual void read_XPeakPosSA(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ZPeakPosSA acquisition result.
 */
	virtual void read_ZPeakPosSA(Tango::Attribute &attr);
/**
 *	Extract real attribute values for SumMeanSA acquisition result.
 */
	virtual void read_SumMeanSA(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ADCEnabled acquisition result.
 */
	virtual void read_ADCEnabled(Tango::Attribute &attr);
/**
 *	Write ADCEnabled attribute values to hardware.
 */
	virtual void write_ADCEnabled(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for ADCBufferSize acquisition result.
 */
	virtual void read_ADCBufferSize(Tango::Attribute &attr);
/**
 *	Write ADCBufferSize attribute values to hardware.
 */
	virtual void write_ADCBufferSize(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for PMOffset acquisition result.
 */
	virtual void read_PMOffset(Tango::Attribute &attr);
/**
 *	Write PMOffset attribute values to hardware.
 */
	virtual void write_PMOffset(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for PMNotified acquisition result.
 */
	virtual void read_PMNotified(Tango::Attribute &attr);
/**
 *	Extract real attribute values for PMNotificationCounter acquisition result.
 */
	virtual void read_PMNotificationCounter(Tango::Attribute &attr);
/**
 *	Extract real attribute values for InterlockXNotified acquisition result.
 */
	virtual void read_InterlockXNotified(Tango::Attribute &attr);
/**
 *	Extract real attribute values for InterlockZNotified acquisition result.
 */
	virtual void read_InterlockZNotified(Tango::Attribute &attr);
/**
 *	Extract real attribute values for InterlockAttnNotified acquisition result.
 */
	virtual void read_InterlockAttnNotified(Tango::Attribute &attr);
/**
 *	Extract real attribute values for InterlockADCPreFilterNotified acquisition result.
 */
	virtual void read_InterlockADCPreFilterNotified(Tango::Attribute &attr);
/**
 *	Extract real attribute values for InterlockADCPostFilterNotified acquisition result.
 */
	virtual void read_InterlockADCPostFilterNotified(Tango::Attribute &attr);
/**
 *	Extract real attribute values for XLow acquisition result.
 */
	virtual void read_XLow(Tango::Attribute &attr);
/**
 *	Extract real attribute values for XHigh acquisition result.
 */
	virtual void read_XHigh(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ZLow acquisition result.
 */
	virtual void read_ZLow(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ZHigh acquisition result.
 */
	virtual void read_ZHigh(Tango::Attribute &attr);
/**
 *	Extract real attribute values for AutoSwitchingEnabled acquisition result.
 */
	virtual void read_AutoSwitchingEnabled(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Switches acquisition result.
 */
	virtual void read_Switches(Tango::Attribute &attr);
/**
 *	Write Switches attribute values to hardware.
 */
	virtual void write_Switches(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for ExternalSwitching acquisition result.
 */
	virtual void read_ExternalSwitching(Tango::Attribute &attr);
/**
 *	Write ExternalSwitching attribute values to hardware.
 */
	virtual void write_ExternalSwitching(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for SwitchingDelay acquisition result.
 */
	virtual void read_SwitchingDelay(Tango::Attribute &attr);
/**
 *	Write SwitchingDelay attribute values to hardware.
 */
	virtual void write_SwitchingDelay(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for OffsetTune acquisition result.
 */
	virtual void read_OffsetTune(Tango::Attribute &attr);
/**
 *	Write OffsetTune attribute values to hardware.
 */
	virtual void write_OffsetTune(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for CompensateTune acquisition result.
 */
	virtual void read_CompensateTune(Tango::Attribute &attr);
/**
 *	Write CompensateTune attribute values to hardware.
 */
	virtual void write_CompensateTune(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for DSCMode acquisition result.
 */
	virtual void read_DSCMode(Tango::Attribute &attr);
/**
 *	Write DSCMode attribute values to hardware.
 */
	virtual void write_DSCMode(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for AGCEnabled acquisition result.
 */
	virtual void read_AGCEnabled(Tango::Attribute &attr);
/**
 *	Write AGCEnabled attribute values to hardware.
 */
	virtual void write_AGCEnabled(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Gain acquisition result.
 */
	virtual void read_Gain(Tango::Attribute &attr);
/**
 *	Write Gain attribute values to hardware.
 */
	virtual void write_Gain(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for HasMAFSupport acquisition result.
 */
	virtual void read_HasMAFSupport(Tango::Attribute &attr);
/**
 *	Extract real attribute values for MAFLength acquisition result.
 */
	virtual void read_MAFLength(Tango::Attribute &attr);
/**
 *	Write MAFLength attribute values to hardware.
 */
	virtual void write_MAFLength(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for MAFDelay acquisition result.
 */
	virtual void read_MAFDelay(Tango::Attribute &attr);
/**
 *	Write MAFDelay attribute values to hardware.
 */
	virtual void write_MAFDelay(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for MachineTime acquisition result.
 */
	virtual void read_MachineTime(Tango::Attribute &attr);
/**
 *	Write MachineTime attribute values to hardware.
 */
	virtual void write_MachineTime(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for TimePhase acquisition result.
 */
	virtual void read_TimePhase(Tango::Attribute &attr);
/**
 *	Write TimePhase attribute values to hardware.
 */
	virtual void write_TimePhase(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for SystemTime acquisition result.
 */
	virtual void read_SystemTime(Tango::Attribute &attr);
/**
 *	Write SystemTime attribute values to hardware.
 */
	virtual void write_SystemTime(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for SCPLLStatus acquisition result.
 */
	virtual void read_SCPLLStatus(Tango::Attribute &attr);
/**
 *	Extract real attribute values for MCPLLStatus acquisition result.
 */
	virtual void read_MCPLLStatus(Tango::Attribute &attr);
/**
 *	Extract real attribute values for HWTemperature acquisition result.
 */
	virtual void read_HWTemperature(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Fan1Speed acquisition result.
 */
	virtual void read_Fan1Speed(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Fan2Speed acquisition result.
 */
	virtual void read_Fan2Speed(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Incoherence acquisition result.
 */
	virtual void read_Incoherence(Tango::Attribute &attr);
/**
 *	Extract real attribute values for RefIncoherence acquisition result.
 */
	virtual void read_RefIncoherence(Tango::Attribute &attr);
/**
 *	Extract real attribute values for MaxIncoherence acquisition result.
 */
	virtual void read_MaxIncoherence(Tango::Attribute &attr);
/**
 *	Write MaxIncoherence attribute values to hardware.
 */
	virtual void write_MaxIncoherence(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for MaxIncoherenceDrift acquisition result.
 */
	virtual void read_MaxIncoherenceDrift(Tango::Attribute &attr);
/**
 *	Write MaxIncoherenceDrift attribute values to hardware.
 */
	virtual void write_MaxIncoherenceDrift(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for UpTime acquisition result.
 */
	virtual void read_UpTime(Tango::Attribute &attr);
/**
 *	Extract real attribute values for CpuUsage acquisition result.
 */
	virtual void read_CpuUsage(Tango::Attribute &attr);
/**
 *	Extract real attribute values for FreeMemory acquisition result.
 */
	virtual void read_FreeMemory(Tango::Attribute &attr);
/**
 *	Extract real attribute values for RamFsUsage acquisition result.
 */
	virtual void read_RamFsUsage(Tango::Attribute &attr);
/**
 *	Extract real attribute values for UseLiberaSAData acquisition result.
 */
	virtual void read_UseLiberaSAData(Tango::Attribute &attr);
/**
 *	Write UseLiberaSAData attribute values to hardware.
 */
	virtual void write_UseLiberaSAData(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for XPosDD acquisition result.
 */
	virtual void read_XPosDD(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ZPosDD acquisition result.
 */
	virtual void read_ZPosDD(Tango::Attribute &attr);
/**
 *	Extract real attribute values for QuadDD acquisition result.
 */
	virtual void read_QuadDD(Tango::Attribute &attr);
/**
 *	Extract real attribute values for SumDD acquisition result.
 */
	virtual void read_SumDD(Tango::Attribute &attr);
/**
 *	Extract real attribute values for VaDD acquisition result.
 */
	virtual void read_VaDD(Tango::Attribute &attr);
/**
 *	Extract real attribute values for VbDD acquisition result.
 */
	virtual void read_VbDD(Tango::Attribute &attr);
/**
 *	Extract real attribute values for VcDD acquisition result.
 */
	virtual void read_VcDD(Tango::Attribute &attr);
/**
 *	Extract real attribute values for VdDD acquisition result.
 */
	virtual void read_VdDD(Tango::Attribute &attr);
/**
 *	Extract real attribute values for XPosSAHistory acquisition result.
 */
	virtual void read_XPosSAHistory(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ZPosSAHistory acquisition result.
 */
	virtual void read_ZPosSAHistory(Tango::Attribute &attr);
/**
 *	Extract real attribute values for SumSAHistory acquisition result.
 */
	virtual void read_SumSAHistory(Tango::Attribute &attr);
/**
 *	Extract real attribute values for XPosPM acquisition result.
 */
	virtual void read_XPosPM(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ZPosPM acquisition result.
 */
	virtual void read_ZPosPM(Tango::Attribute &attr);
/**
 *	Extract real attribute values for QuadPM acquisition result.
 */
	virtual void read_QuadPM(Tango::Attribute &attr);
/**
 *	Extract real attribute values for SumPM acquisition result.
 */
	virtual void read_SumPM(Tango::Attribute &attr);
/**
 *	Extract real attribute values for VaPM acquisition result.
 */
	virtual void read_VaPM(Tango::Attribute &attr);
/**
 *	Extract real attribute values for VbPM acquisition result.
 */
	virtual void read_VbPM(Tango::Attribute &attr);
/**
 *	Extract real attribute values for VcPM acquisition result.
 */
	virtual void read_VcPM(Tango::Attribute &attr);
/**
 *	Extract real attribute values for VdPM acquisition result.
 */
	virtual void read_VdPM(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ADCChannelA acquisition result.
 */
	virtual void read_ADCChannelA(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ADCChannelB acquisition result.
 */
	virtual void read_ADCChannelB(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ADCChannelC acquisition result.
 */
	virtual void read_ADCChannelC(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ADCChannelD acquisition result.
 */
	virtual void read_ADCChannelD(Tango::Attribute &attr);
/**
 *	Extract real attribute values for IaDD acquisition result.
 */
	virtual void read_IaDD(Tango::Attribute &attr);
/**
 *	Extract real attribute values for IbDD acquisition result.
 */
	virtual void read_IbDD(Tango::Attribute &attr);
/**
 *	Extract real attribute values for IcDD acquisition result.
 */
	virtual void read_IcDD(Tango::Attribute &attr);
/**
 *	Extract real attribute values for IdDD acquisition result.
 */
	virtual void read_IdDD(Tango::Attribute &attr);
/**
 *	Extract real attribute values for QaDD acquisition result.
 */
	virtual void read_QaDD(Tango::Attribute &attr);
/**
 *	Extract real attribute values for QbDD acquisition result.
 */
	virtual void read_QbDD(Tango::Attribute &attr);
/**
 *	Extract real attribute values for QcDD acquisition result.
 */
	virtual void read_QcDD(Tango::Attribute &attr);
/**
 *	Extract real attribute values for QdDD acquisition result.
 */
	virtual void read_QdDD(Tango::Attribute &attr);
/**
 *	Extract real attribute values for UserData acquisition result.
 */
	virtual void read_UserData(Tango::Attribute &attr);
/**
 *	Extract real attribute values for InterlockConfiguration acquisition result.
 */
	virtual void read_InterlockConfiguration(Tango::Attribute &attr);
/**
 *	Extract real attribute values for logs acquisition result.
 */
	virtual void read_logs(Tango::Attribute &attr);
/**
 *	Read/Write allowed for LiberaModel attribute.
 */
	virtual bool is_LiberaModel_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for DDEnabled attribute.
 */
	virtual bool is_DDEnabled_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for DDBufferSize attribute.
 */
	virtual bool is_DDBufferSize_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for DDDecimationFactor attribute.
 */
	virtual bool is_DDDecimationFactor_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for DDTriggerOffset attribute.
 */
	virtual bool is_DDTriggerOffset_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for DDBufferFreezingEnabled attribute.
 */
	virtual bool is_DDBufferFreezingEnabled_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for DDBufferFrozen attribute.
 */
	virtual bool is_DDBufferFrozen_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for DDTriggerCounter attribute.
 */
	virtual bool is_DDTriggerCounter_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ExternalTriggerEnabled attribute.
 */
	virtual bool is_ExternalTriggerEnabled_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ExternalTriggerDelay attribute.
 */
	virtual bool is_ExternalTriggerDelay_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for SAEnabled attribute.
 */
	virtual bool is_SAEnabled_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for VaSA attribute.
 */
	virtual bool is_VaSA_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for VbSA attribute.
 */
	virtual bool is_VbSA_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for VcSA attribute.
 */
	virtual bool is_VcSA_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for VdSA attribute.
 */
	virtual bool is_VdSA_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for XPosSA attribute.
 */
	virtual bool is_XPosSA_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ZPosSA attribute.
 */
	virtual bool is_ZPosSA_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for SumSA attribute.
 */
	virtual bool is_SumSA_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for QuadSA attribute.
 */
	virtual bool is_QuadSA_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for CxSA attribute.
 */
	virtual bool is_CxSA_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for CzSA attribute.
 */
	virtual bool is_CzSA_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for SAStatNumSamples attribute.
 */
	virtual bool is_SAStatNumSamples_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for XMeanPosSA attribute.
 */
	virtual bool is_XMeanPosSA_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ZMeanPosSA attribute.
 */
	virtual bool is_ZMeanPosSA_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for XRMSPosSA attribute.
 */
	virtual bool is_XRMSPosSA_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ZRMSPosSA attribute.
 */
	virtual bool is_ZRMSPosSA_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for XPeakPosSA attribute.
 */
	virtual bool is_XPeakPosSA_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ZPeakPosSA attribute.
 */
	virtual bool is_ZPeakPosSA_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for SumMeanSA attribute.
 */
	virtual bool is_SumMeanSA_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ADCEnabled attribute.
 */
	virtual bool is_ADCEnabled_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ADCBufferSize attribute.
 */
	virtual bool is_ADCBufferSize_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for PMOffset attribute.
 */
	virtual bool is_PMOffset_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for PMNotified attribute.
 */
	virtual bool is_PMNotified_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for PMNotificationCounter attribute.
 */
	virtual bool is_PMNotificationCounter_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for InterlockXNotified attribute.
 */
	virtual bool is_InterlockXNotified_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for InterlockZNotified attribute.
 */
	virtual bool is_InterlockZNotified_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for InterlockAttnNotified attribute.
 */
	virtual bool is_InterlockAttnNotified_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for InterlockADCPreFilterNotified attribute.
 */
	virtual bool is_InterlockADCPreFilterNotified_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for InterlockADCPostFilterNotified attribute.
 */
	virtual bool is_InterlockADCPostFilterNotified_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for XLow attribute.
 */
	virtual bool is_XLow_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for XHigh attribute.
 */
	virtual bool is_XHigh_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ZLow attribute.
 */
	virtual bool is_ZLow_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ZHigh attribute.
 */
	virtual bool is_ZHigh_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for AutoSwitchingEnabled attribute.
 */
	virtual bool is_AutoSwitchingEnabled_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Switches attribute.
 */
	virtual bool is_Switches_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ExternalSwitching attribute.
 */
	virtual bool is_ExternalSwitching_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for SwitchingDelay attribute.
 */
	virtual bool is_SwitchingDelay_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for OffsetTune attribute.
 */
	virtual bool is_OffsetTune_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for CompensateTune attribute.
 */
	virtual bool is_CompensateTune_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for DSCMode attribute.
 */
	virtual bool is_DSCMode_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for AGCEnabled attribute.
 */
	virtual bool is_AGCEnabled_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Gain attribute.
 */
	virtual bool is_Gain_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for HasMAFSupport attribute.
 */
	virtual bool is_HasMAFSupport_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for MAFLength attribute.
 */
	virtual bool is_MAFLength_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for MAFDelay attribute.
 */
	virtual bool is_MAFDelay_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for MachineTime attribute.
 */
	virtual bool is_MachineTime_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for TimePhase attribute.
 */
	virtual bool is_TimePhase_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for SystemTime attribute.
 */
	virtual bool is_SystemTime_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for SCPLLStatus attribute.
 */
	virtual bool is_SCPLLStatus_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for MCPLLStatus attribute.
 */
	virtual bool is_MCPLLStatus_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for HWTemperature attribute.
 */
	virtual bool is_HWTemperature_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Fan1Speed attribute.
 */
	virtual bool is_Fan1Speed_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Fan2Speed attribute.
 */
	virtual bool is_Fan2Speed_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Incoherence attribute.
 */
	virtual bool is_Incoherence_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for RefIncoherence attribute.
 */
	virtual bool is_RefIncoherence_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for MaxIncoherence attribute.
 */
	virtual bool is_MaxIncoherence_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for MaxIncoherenceDrift attribute.
 */
	virtual bool is_MaxIncoherenceDrift_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for UpTime attribute.
 */
	virtual bool is_UpTime_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for CpuUsage attribute.
 */
	virtual bool is_CpuUsage_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for FreeMemory attribute.
 */
	virtual bool is_FreeMemory_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for RamFsUsage attribute.
 */
	virtual bool is_RamFsUsage_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for UseLiberaSAData attribute.
 */
	virtual bool is_UseLiberaSAData_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for XPosDD attribute.
 */
	virtual bool is_XPosDD_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ZPosDD attribute.
 */
	virtual bool is_ZPosDD_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for QuadDD attribute.
 */
	virtual bool is_QuadDD_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for SumDD attribute.
 */
	virtual bool is_SumDD_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for VaDD attribute.
 */
	virtual bool is_VaDD_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for VbDD attribute.
 */
	virtual bool is_VbDD_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for VcDD attribute.
 */
	virtual bool is_VcDD_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for VdDD attribute.
 */
	virtual bool is_VdDD_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for XPosSAHistory attribute.
 */
	virtual bool is_XPosSAHistory_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ZPosSAHistory attribute.
 */
	virtual bool is_ZPosSAHistory_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for SumSAHistory attribute.
 */
	virtual bool is_SumSAHistory_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for XPosPM attribute.
 */
	virtual bool is_XPosPM_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ZPosPM attribute.
 */
	virtual bool is_ZPosPM_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for QuadPM attribute.
 */
	virtual bool is_QuadPM_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for SumPM attribute.
 */
	virtual bool is_SumPM_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for VaPM attribute.
 */
	virtual bool is_VaPM_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for VbPM attribute.
 */
	virtual bool is_VbPM_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for VcPM attribute.
 */
	virtual bool is_VcPM_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for VdPM attribute.
 */
	virtual bool is_VdPM_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ADCChannelA attribute.
 */
	virtual bool is_ADCChannelA_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ADCChannelB attribute.
 */
	virtual bool is_ADCChannelB_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ADCChannelC attribute.
 */
	virtual bool is_ADCChannelC_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ADCChannelD attribute.
 */
	virtual bool is_ADCChannelD_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for IaDD attribute.
 */
	virtual bool is_IaDD_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for IbDD attribute.
 */
	virtual bool is_IbDD_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for IcDD attribute.
 */
	virtual bool is_IcDD_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for IdDD attribute.
 */
	virtual bool is_IdDD_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for QaDD attribute.
 */
	virtual bool is_QaDD_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for QbDD attribute.
 */
	virtual bool is_QbDD_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for QcDD attribute.
 */
	virtual bool is_QcDD_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for QdDD attribute.
 */
	virtual bool is_QdDD_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for UserData attribute.
 */
	virtual bool is_UserData_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for InterlockConfiguration attribute.
 */
	virtual bool is_InterlockConfiguration_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for logs attribute.
 */
	virtual bool is_logs_allowed(Tango::AttReqType type);
/**
 *	Execution allowed for GetParameters command.
 */
	virtual bool is_GetParameters_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for UnfreezeDDBuffer command.
 */
	virtual bool is_UnfreezeDDBuffer_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for EnableDDBufferFreezing command.
 */
	virtual bool is_EnableDDBufferFreezing_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for DisableDDBufferFreezing command.
 */
	virtual bool is_DisableDDBufferFreezing_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for EnableDD command.
 */
	virtual bool is_EnableDD_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for DisableDD command.
 */
	virtual bool is_DisableDD_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for EnableSA command.
 */
	virtual bool is_EnableSA_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for DisableSA command.
 */
	virtual bool is_DisableSA_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for ResetPMNotification command.
 */
	virtual bool is_ResetPMNotification_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for ResetInterlockNotification command.
 */
	virtual bool is_ResetInterlockNotification_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for SetInterlockConfiguration command.
 */
	virtual bool is_SetInterlockConfiguration_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for EnableADC command.
 */
	virtual bool is_EnableADC_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for DisableADC command.
 */
	virtual bool is_DisableADC_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for SetTimeOnNextTrigger command.
 */
	virtual bool is_SetTimeOnNextTrigger_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for ReadFAData command.
 */
	virtual bool is_ReadFAData_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for WriteFAData command.
 */
	virtual bool is_WriteFAData_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for SaveDSCParameters command.
 */
	virtual bool is_SaveDSCParameters_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for ReloadSystemProperties command.
 */
	virtual bool is_ReloadSystemProperties_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for SetRefIncoherence command.
 */
	virtual bool is_SetRefIncoherence_allowed(const CORBA::Any &any);
/**
 * This command gets the device state (stored in its <i>device_state</i> data member) and returns it to the caller.
 *	@return	State Code
 *	@exception DevFailed
 */
	virtual Tango::DevState	dev_state();
/**
 * This command gets the device status (stored in its <i>device_status</i> data member) and returns it to the caller.
 *	@return	Status description
 *	@exception DevFailed
 */
	virtual Tango::ConstDevString	dev_status();
/**
 * Retruns the current gains and offsets (i.e. the parameters used for position computation)
 *	@return	The BPM gain and offsets
 *	@exception DevFailed
 */
	Tango::DevVarDoubleStringArray	*get_parameters();
/**
 * Unfreezes the DD buffer
 *	@exception DevFailed
 */
	void	unfreeze_ddbuffer();
/**
 * Enables the DD buffer freezing mechanism
 *	@exception DevFailed
 */
	void	enable_ddbuffer_freezing();
/**
 * Disables the DD buffer freezing mechanism
 *	@exception DevFailed
 */
	void	disable_ddbuffer_freezing();
/**
 * Enables the so called "data on demand" (i.e. first turns) data source
 *	@exception DevFailed
 */
	void	enable_dd();
/**
 * Disables the so called "data on demand" (i.e. first turns) data source
 *	@exception DevFailed
 */
	void	disable_dd();
/**
 * Enables the so called "slow acquisition" data source
 *	@exception DevFailed
 */
	void	enable_sa();
/**
 * Disables the so called "slow acquisition" data source
 *	@exception DevFailed
 */
	void	disable_sa();
/**
 * 
 *	@exception DevFailed
 */
	void	reset_pmnotification();
/**
 * Resets the interlock notification flags to false
 *	@exception DevFailed
 */
	void	reset_interlock_notification();
/**
 * Change interlock configuration using the InterlockConfiguration class (or device) property.
 *	Only  modify  the interlock configuration, the remaining env. parameters remain unchanged.
 *	@exception DevFailed
 */
	void	set_interlock_configuration();
/**
 * Enables the so called ADC data source
 *	@exception DevFailed
 */
	void	enable_adc();
/**
 * Disables the so called ADC data source
 *	@exception DevFailed
 */
	void	disable_adc();
/**
 * Applies both machine et system time values on next trigger
 *	@exception DevFailed
 */
	void	set_time_on_next_trigger();
/**
 * Statring from[offest] in FA data block, reads [size of elems] * [num of elems] bytes.
 *	@param	argin	The reading parameters: [0]:offset in FA data block, [1]:size of elems, [2]:num of elems
 *	@return	The data [as an array of bytes]
 *	@exception DevFailed
 */
	Tango::DevVarLongArray	*read_fadata(const Tango::DevVarLongArray *);
/**
 * Starting from [offset] in Fa data block, writes [size of elems * num of elems].
 *	The actual data to be written starts at index [4] in the input array.
 *	@param	argin	The writting parameters: [0]:offset in FA data block, bytes[1]:size of elems, [2]:num of elems, [3, ...]: actual to data to be written
 *	@exception DevFailed
 */
	void	write_fadata(const Tango::DevVarLongArray *);
/**
 * Saves the current DSC parameters
 *	@exception DevFailed
 */
	void	save_dscparameters();
/**
 * 
 *	@exception DevFailed
 */
	void	reload_system_properties();
/**
 * Set the actual incoherence value as refeference value for the drift alarm calculation.
 *	@exception DevFailed
 */
	void	set_ref_incoherence();

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

  //  Here is the end of the automatic code generation part
  //-------------------------------------------------------------
protected:
  //  Add your own data members here
  //-----------------------------------------

  //- changes the interlock config from the UserDefinedStartupEnvParameters property
  void set_interlock_config_from_property();

  //- true if (at least) a critical device property is missing, false otherwise
  bool critical_properties_missing;

  //- underlying Libera hardware
  BPM * bpm_hw;

  //- the BPM DD data (data on demand)
  DDData * dd_data;

  //- the BPM ADC data (adc values)
  ADCData * adc_data;
  
  //- the BPM SA data (slow acquisition)
  SAData * sa_data;
  
  //- the BPM PM data (post mortem)
  DDData * pm_data;
  
  //- dd activation flag
  bool dd_enabled;

  //- sa activation flag
  bool sa_enabled;

  //- adc activation flag
  bool adc_enabled;
  
  //- the trigger_counter
  long trigger_counter;

  //- DD (i.e. turn-by-turn) cache status
  bool dd_cache_enabled;
  bool dd_cache_frozen;

  //- external trigger status
  bool external_trigger_enabled;

  //- bpm location
  BPMLocation bpm_location;

  //- count device instances in order to prevent more than one device
  //- to be instanciated into the same process (not 100% thread safe
  //- due to asynch notification mechanism)
  static int instance_counter;
  
  //- pos threshold (for interlock)
  FPDataType x_lo;
  FPDataType x_hi;
  FPDataType z_lo;
  FPDataType z_hi;
  
  //- dd buffer offset
  Tango::DevLong dd_buffer_offset;
  
  //- pm stuffs
  bool pm_notified;
  short pm_event_counter;
  
  //- interlock status
  bool intl_x_notified;
  bool intl_z_notified;
  bool intl_attn_notified;
  bool intl_adc_pre_filter_notified;
  bool intl_adc_post_filter_notified;
  
  //- auto switching enabled
  bool auto_switching_enabled;
  
  //- AGC enabled
  bool agc_enabled;
  
  //- using SA pos data from FPGA?
  bool using_fpga_sa_pos;
  
  //- cuurent input gain
  FPDataType gain;
  
  //- storage for current Interlock configuration
  FPDataType ilk_config[kILK_NUM_PARAMS];
  
  //- SA pos. statistics
  FPDataType sa_x_mean;
  FPDataType sa_z_mean;
  FPDataType sa_s_mean;
  FPDataType sa_x_rms;
  FPDataType sa_z_rms;
  FPDataType sa_x_peak;
  FPDataType sa_z_peak;
  
  //- time: MT, ST and phase
  FPDataType mt;
  FPDataType st;
  Tango::DevLong tp;
  
  //- DSC mode
  short dsc_mode;
  
  //- BPM hardware status
  bpm::BPM::BPMHwStatus bpm_hw_status;
  
  //- the Rf/Sf ratio (machine dependent)
  FPDataType rf_sf_ratio; 
  
  // ADC source switching
  bool external_switching_enabled;
  Tango::DevLong switching_delay;
  
  // Compensation tune (mtvcxoff and mtncoshft)
  bool tune_compensation_enabled;
  Tango::DevLong tune_offset;
  
  // External trigger delay
  Tango::DevLong external_trigger_delay;
  
  // Post mortem offset
  Tango::DevLong pm_offset;
  
  // Moving average filter length and delay
  Tango::DevLong maf_length;
  Tango::DevLong maf_delay;
  Tango::DevBoolean maf_support;
  
	// Incoherence value 
	FPDataType incoherence;
	
	// Reference and alarm configuration values for the incoherence alarm
	FPDataType ref_incoherence;
	FPDataType max_incoherence;
	FPDataType max_drift_incoherence;
  bool incoherence_out_of_range ();

  //- dynamic attributes repository
  DynamicAttrHelper dyn_attrs;
  
  //- logging trick (tanks Julien)
  InnerAppender * m_appender;
  InnerAppender::LogList m_logs;
  Tango::DevVarStringArray m_logs_array;
};

} // namespace


#endif // _LIBERA_H
