//=============================================================================
//
// file :         LiberaClass.h
//
// description :  Include for the LiberaClass root class.
//                This class is represents the singleton class for
//                the Libera device class.
//                It contains all properties and methods which the
//                Libera requires only once e.g. the commands.
//
// project :      TANGO Device Server
//
// $Author: nleclercq $
//
// copyleft :     Synchrotron SOLEIL
//                L'Orme des Merisiers
//                Saint-Aubin - BP 48
//
//=============================================================================
//
//      This file is generated by POGO
//  (Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _LIBERACLASS_H
#define _LIBERACLASS_H

#include <tango.h>
#include <Libera.h>

namespace Libera_ns
{
//=====================================
//	Define classes for attributes
//=====================================
class logsAttrib: public Tango::SpectrumAttr
{
public:
	logsAttrib():SpectrumAttr("logs", Tango::DEV_STRING, Tango::READ, 2048) {};
	~logsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_logs(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_logs_allowed(ty);}
};

class InterlockConfigurationAttrib: public Tango::SpectrumAttr
{
public:
	InterlockConfigurationAttrib():SpectrumAttr("InterlockConfiguration", Tango::DEV_DOUBLE, Tango::READ, 8) {};
	~InterlockConfigurationAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_InterlockConfiguration(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_InterlockConfiguration_allowed(ty);}
};

class UserDataAttrib: public Tango::SpectrumAttr
{
public:
	UserDataAttrib():SpectrumAttr("UserData", Tango::DEV_SHORT, Tango::READ, 256) {};
	~UserDataAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_UserData(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_UserData_allowed(ty);}
};

class QdDDAttrib: public Tango::SpectrumAttr
{
public:
	QdDDAttrib():SpectrumAttr("QdDD", Tango::DEV_DOUBLE, Tango::READ, 250000) {};
	~QdDDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_QdDD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_QdDD_allowed(ty);}
};

class QcDDAttrib: public Tango::SpectrumAttr
{
public:
	QcDDAttrib():SpectrumAttr("QcDD", Tango::DEV_DOUBLE, Tango::READ, 250000) {};
	~QcDDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_QcDD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_QcDD_allowed(ty);}
};

class QbDDAttrib: public Tango::SpectrumAttr
{
public:
	QbDDAttrib():SpectrumAttr("QbDD", Tango::DEV_DOUBLE, Tango::READ, 250000) {};
	~QbDDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_QbDD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_QbDD_allowed(ty);}
};

class QaDDAttrib: public Tango::SpectrumAttr
{
public:
	QaDDAttrib():SpectrumAttr("QaDD", Tango::DEV_DOUBLE, Tango::READ, 250000) {};
	~QaDDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_QaDD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_QaDD_allowed(ty);}
};

class IdDDAttrib: public Tango::SpectrumAttr
{
public:
	IdDDAttrib():SpectrumAttr("IdDD", Tango::DEV_DOUBLE, Tango::READ, 250000) {};
	~IdDDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_IdDD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_IdDD_allowed(ty);}
};

class IcDDAttrib: public Tango::SpectrumAttr
{
public:
	IcDDAttrib():SpectrumAttr("IcDD", Tango::DEV_DOUBLE, Tango::READ, 250000) {};
	~IcDDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_IcDD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_IcDD_allowed(ty);}
};

class IbDDAttrib: public Tango::SpectrumAttr
{
public:
	IbDDAttrib():SpectrumAttr("IbDD", Tango::DEV_DOUBLE, Tango::READ, 250000) {};
	~IbDDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_IbDD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_IbDD_allowed(ty);}
};

class IaDDAttrib: public Tango::SpectrumAttr
{
public:
	IaDDAttrib():SpectrumAttr("IaDD", Tango::DEV_DOUBLE, Tango::READ, 250000) {};
	~IaDDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_IaDD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_IaDD_allowed(ty);}
};

class ADCChannelDAttrib: public Tango::SpectrumAttr
{
public:
	ADCChannelDAttrib():SpectrumAttr("ADCChannelD", Tango::DEV_SHORT, Tango::READ, 250000) {};
	~ADCChannelDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_ADCChannelD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_ADCChannelD_allowed(ty);}
};

class ADCChannelCAttrib: public Tango::SpectrumAttr
{
public:
	ADCChannelCAttrib():SpectrumAttr("ADCChannelC", Tango::DEV_SHORT, Tango::READ, 250000) {};
	~ADCChannelCAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_ADCChannelC(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_ADCChannelC_allowed(ty);}
};

class ADCChannelBAttrib: public Tango::SpectrumAttr
{
public:
	ADCChannelBAttrib():SpectrumAttr("ADCChannelB", Tango::DEV_SHORT, Tango::READ, 250000) {};
	~ADCChannelBAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_ADCChannelB(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_ADCChannelB_allowed(ty);}
};

class ADCChannelAAttrib: public Tango::SpectrumAttr
{
public:
	ADCChannelAAttrib():SpectrumAttr("ADCChannelA", Tango::DEV_SHORT, Tango::READ, 250000) {};
	~ADCChannelAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_ADCChannelA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_ADCChannelA_allowed(ty);}
};

class VdPMAttrib: public Tango::SpectrumAttr
{
public:
	VdPMAttrib():SpectrumAttr("VdPM", Tango::DEV_DOUBLE, Tango::READ, 16384) {};
	~VdPMAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_VdPM(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_VdPM_allowed(ty);}
};

class VcPMAttrib: public Tango::SpectrumAttr
{
public:
	VcPMAttrib():SpectrumAttr("VcPM", Tango::DEV_DOUBLE, Tango::READ, 16384) {};
	~VcPMAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_VcPM(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_VcPM_allowed(ty);}
};

class VbPMAttrib: public Tango::SpectrumAttr
{
public:
	VbPMAttrib():SpectrumAttr("VbPM", Tango::DEV_DOUBLE, Tango::READ, 16384) {};
	~VbPMAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_VbPM(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_VbPM_allowed(ty);}
};

class VaPMAttrib: public Tango::SpectrumAttr
{
public:
	VaPMAttrib():SpectrumAttr("VaPM", Tango::DEV_DOUBLE, Tango::READ, 16384) {};
	~VaPMAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_VaPM(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_VaPM_allowed(ty);}
};

class SumPMAttrib: public Tango::SpectrumAttr
{
public:
	SumPMAttrib():SpectrumAttr("SumPM", Tango::DEV_DOUBLE, Tango::READ, 16384) {};
	~SumPMAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_SumPM(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_SumPM_allowed(ty);}
};

class QuadPMAttrib: public Tango::SpectrumAttr
{
public:
	QuadPMAttrib():SpectrumAttr("QuadPM", Tango::DEV_DOUBLE, Tango::READ, 16384) {};
	~QuadPMAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_QuadPM(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_QuadPM_allowed(ty);}
};

class ZPosPMAttrib: public Tango::SpectrumAttr
{
public:
	ZPosPMAttrib():SpectrumAttr("ZPosPM", Tango::DEV_DOUBLE, Tango::READ, 16384) {};
	~ZPosPMAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_ZPosPM(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_ZPosPM_allowed(ty);}
};

class XPosPMAttrib: public Tango::SpectrumAttr
{
public:
	XPosPMAttrib():SpectrumAttr("XPosPM", Tango::DEV_DOUBLE, Tango::READ, 16384) {};
	~XPosPMAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_XPosPM(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_XPosPM_allowed(ty);}
};

class SumSAHistoryAttrib: public Tango::SpectrumAttr
{
public:
	SumSAHistoryAttrib():SpectrumAttr("SumSAHistory", Tango::DEV_DOUBLE, Tango::READ, 16384) {};
	~SumSAHistoryAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_SumSAHistory(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_SumSAHistory_allowed(ty);}
};

class ZPosSAHistoryAttrib: public Tango::SpectrumAttr
{
public:
	ZPosSAHistoryAttrib():SpectrumAttr("ZPosSAHistory", Tango::DEV_DOUBLE, Tango::READ, 16384) {};
	~ZPosSAHistoryAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_ZPosSAHistory(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_ZPosSAHistory_allowed(ty);}
};

class XPosSAHistoryAttrib: public Tango::SpectrumAttr
{
public:
	XPosSAHistoryAttrib():SpectrumAttr("XPosSAHistory", Tango::DEV_DOUBLE, Tango::READ, 16384) {};
	~XPosSAHistoryAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_XPosSAHistory(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_XPosSAHistory_allowed(ty);}
};

class VdDDAttrib: public Tango::SpectrumAttr
{
public:
	VdDDAttrib():SpectrumAttr("VdDD", Tango::DEV_DOUBLE, Tango::READ, 250000) {};
	~VdDDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_VdDD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_VdDD_allowed(ty);}
};

class VcDDAttrib: public Tango::SpectrumAttr
{
public:
	VcDDAttrib():SpectrumAttr("VcDD", Tango::DEV_DOUBLE, Tango::READ, 250000) {};
	~VcDDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_VcDD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_VcDD_allowed(ty);}
};

class VbDDAttrib: public Tango::SpectrumAttr
{
public:
	VbDDAttrib():SpectrumAttr("VbDD", Tango::DEV_DOUBLE, Tango::READ, 250000) {};
	~VbDDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_VbDD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_VbDD_allowed(ty);}
};

class VaDDAttrib: public Tango::SpectrumAttr
{
public:
	VaDDAttrib():SpectrumAttr("VaDD", Tango::DEV_DOUBLE, Tango::READ, 250000) {};
	~VaDDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_VaDD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_VaDD_allowed(ty);}
};

class SumDDAttrib: public Tango::SpectrumAttr
{
public:
	SumDDAttrib():SpectrumAttr("SumDD", Tango::DEV_DOUBLE, Tango::READ, 250000) {};
	~SumDDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_SumDD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_SumDD_allowed(ty);}
};

class QuadDDAttrib: public Tango::SpectrumAttr
{
public:
	QuadDDAttrib():SpectrumAttr("QuadDD", Tango::DEV_DOUBLE, Tango::READ, 250000) {};
	~QuadDDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_QuadDD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_QuadDD_allowed(ty);}
};

class ZPosDDAttrib: public Tango::SpectrumAttr
{
public:
	ZPosDDAttrib():SpectrumAttr("ZPosDD", Tango::DEV_DOUBLE, Tango::READ, 250000) {};
	~ZPosDDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_ZPosDD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_ZPosDD_allowed(ty);}
};

class XPosDDAttrib: public Tango::SpectrumAttr
{
public:
	XPosDDAttrib():SpectrumAttr("XPosDD", Tango::DEV_DOUBLE, Tango::READ, 250000) {};
	~XPosDDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_XPosDD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_XPosDD_allowed(ty);}
};

class UseLiberaSADataAttrib: public Tango::Attr
{
public:
	UseLiberaSADataAttrib():Attr("UseLiberaSAData", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~UseLiberaSADataAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_UseLiberaSAData(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_UseLiberaSAData(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_UseLiberaSAData_allowed(ty);}
};

class RamFsUsageAttrib: public Tango::Attr
{
public:
	RamFsUsageAttrib():Attr("RamFsUsage", Tango::DEV_LONG, Tango::READ) {};
	~RamFsUsageAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_RamFsUsage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_RamFsUsage_allowed(ty);}
};

class FreeMemoryAttrib: public Tango::Attr
{
public:
	FreeMemoryAttrib():Attr("FreeMemory", Tango::DEV_LONG, Tango::READ) {};
	~FreeMemoryAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_FreeMemory(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_FreeMemory_allowed(ty);}
};

class CpuUsageAttrib: public Tango::Attr
{
public:
	CpuUsageAttrib():Attr("CpuUsage", Tango::DEV_LONG, Tango::READ) {};
	~CpuUsageAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_CpuUsage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_CpuUsage_allowed(ty);}
};

class UpTimeAttrib: public Tango::Attr
{
public:
	UpTimeAttrib():Attr("UpTime", Tango::DEV_LONG, Tango::READ) {};
	~UpTimeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_UpTime(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_UpTime_allowed(ty);}
};

class MaxIncoherenceDriftAttrib: public Tango::Attr
{
public:
	MaxIncoherenceDriftAttrib():Attr("MaxIncoherenceDrift", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~MaxIncoherenceDriftAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_MaxIncoherenceDrift(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_MaxIncoherenceDrift(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_MaxIncoherenceDrift_allowed(ty);}
};

class MaxIncoherenceAttrib: public Tango::Attr
{
public:
	MaxIncoherenceAttrib():Attr("MaxIncoherence", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~MaxIncoherenceAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_MaxIncoherence(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_MaxIncoherence(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_MaxIncoherence_allowed(ty);}
};

class RefIncoherenceAttrib: public Tango::Attr
{
public:
	RefIncoherenceAttrib():Attr("RefIncoherence", Tango::DEV_DOUBLE, Tango::READ) {};
	~RefIncoherenceAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_RefIncoherence(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_RefIncoherence_allowed(ty);}
};

class IncoherenceAttrib: public Tango::Attr
{
public:
	IncoherenceAttrib():Attr("Incoherence", Tango::DEV_DOUBLE, Tango::READ) {};
	~IncoherenceAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_Incoherence(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_Incoherence_allowed(ty);}
};

class Fan2SpeedAttrib: public Tango::Attr
{
public:
	Fan2SpeedAttrib():Attr("Fan2Speed", Tango::DEV_SHORT, Tango::READ) {};
	~Fan2SpeedAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_Fan2Speed(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_Fan2Speed_allowed(ty);}
};

class Fan1SpeedAttrib: public Tango::Attr
{
public:
	Fan1SpeedAttrib():Attr("Fan1Speed", Tango::DEV_SHORT, Tango::READ) {};
	~Fan1SpeedAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_Fan1Speed(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_Fan1Speed_allowed(ty);}
};

class HWTemperatureAttrib: public Tango::Attr
{
public:
	HWTemperatureAttrib():Attr("HWTemperature", Tango::DEV_SHORT, Tango::READ) {};
	~HWTemperatureAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_HWTemperature(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_HWTemperature_allowed(ty);}
};

class MCPLLStatusAttrib: public Tango::Attr
{
public:
	MCPLLStatusAttrib():Attr("MCPLLStatus", Tango::DEV_BOOLEAN, Tango::READ) {};
	~MCPLLStatusAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_MCPLLStatus(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_MCPLLStatus_allowed(ty);}
};

class SCPLLStatusAttrib: public Tango::Attr
{
public:
	SCPLLStatusAttrib():Attr("SCPLLStatus", Tango::DEV_BOOLEAN, Tango::READ) {};
	~SCPLLStatusAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_SCPLLStatus(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_SCPLLStatus_allowed(ty);}
};

class SystemTimeAttrib: public Tango::Attr
{
public:
	SystemTimeAttrib():Attr("SystemTime", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~SystemTimeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_SystemTime(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_SystemTime(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_SystemTime_allowed(ty);}
};

class TimePhaseAttrib: public Tango::Attr
{
public:
	TimePhaseAttrib():Attr("TimePhase", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~TimePhaseAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_TimePhase(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_TimePhase(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_TimePhase_allowed(ty);}
};

class MachineTimeAttrib: public Tango::Attr
{
public:
	MachineTimeAttrib():Attr("MachineTime", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~MachineTimeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_MachineTime(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_MachineTime(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_MachineTime_allowed(ty);}
};

class MAFDelayAttrib: public Tango::Attr
{
public:
	MAFDelayAttrib():Attr("MAFDelay", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~MAFDelayAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_MAFDelay(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_MAFDelay(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_MAFDelay_allowed(ty);}
};

class MAFLengthAttrib: public Tango::Attr
{
public:
	MAFLengthAttrib():Attr("MAFLength", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~MAFLengthAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_MAFLength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_MAFLength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_MAFLength_allowed(ty);}
};

class HasMAFSupportAttrib: public Tango::Attr
{
public:
	HasMAFSupportAttrib():Attr("HasMAFSupport", Tango::DEV_BOOLEAN, Tango::READ) {};
	~HasMAFSupportAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_HasMAFSupport(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_HasMAFSupport_allowed(ty);}
};

class GainAttrib: public Tango::Attr
{
public:
	GainAttrib():Attr("Gain", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~GainAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_Gain(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_Gain(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_Gain_allowed(ty);}
};

class AGCEnabledAttrib: public Tango::Attr
{
public:
	AGCEnabledAttrib():Attr("AGCEnabled", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~AGCEnabledAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_AGCEnabled(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_AGCEnabled(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_AGCEnabled_allowed(ty);}
};

class DSCModeAttrib: public Tango::Attr
{
public:
	DSCModeAttrib():Attr("DSCMode", Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~DSCModeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_DSCMode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_DSCMode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_DSCMode_allowed(ty);}
};

class CompensateTuneAttrib: public Tango::Attr
{
public:
	CompensateTuneAttrib():Attr("CompensateTune", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~CompensateTuneAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_CompensateTune(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_CompensateTune(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_CompensateTune_allowed(ty);}
};

class OffsetTuneAttrib: public Tango::Attr
{
public:
	OffsetTuneAttrib():Attr("OffsetTune", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~OffsetTuneAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_OffsetTune(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_OffsetTune(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_OffsetTune_allowed(ty);}
};

class SwitchingDelayAttrib: public Tango::Attr
{
public:
	SwitchingDelayAttrib():Attr("SwitchingDelay", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~SwitchingDelayAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_SwitchingDelay(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_SwitchingDelay(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_SwitchingDelay_allowed(ty);}
};

class ExternalSwitchingAttrib: public Tango::Attr
{
public:
	ExternalSwitchingAttrib():Attr("ExternalSwitching", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~ExternalSwitchingAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_ExternalSwitching(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_ExternalSwitching(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_ExternalSwitching_allowed(ty);}
};

class SwitchesAttrib: public Tango::Attr
{
public:
	SwitchesAttrib():Attr("Switches", Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~SwitchesAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_Switches(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_Switches(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_Switches_allowed(ty);}
};

class AutoSwitchingEnabledAttrib: public Tango::Attr
{
public:
	AutoSwitchingEnabledAttrib():Attr("AutoSwitchingEnabled", Tango::DEV_BOOLEAN, Tango::READ) {};
	~AutoSwitchingEnabledAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_AutoSwitchingEnabled(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_AutoSwitchingEnabled_allowed(ty);}
};

class ZHighAttrib: public Tango::Attr
{
public:
	ZHighAttrib():Attr("ZHigh", Tango::DEV_DOUBLE, Tango::READ) {};
	~ZHighAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_ZHigh(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_ZHigh_allowed(ty);}
};

class ZLowAttrib: public Tango::Attr
{
public:
	ZLowAttrib():Attr("ZLow", Tango::DEV_DOUBLE, Tango::READ) {};
	~ZLowAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_ZLow(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_ZLow_allowed(ty);}
};

class XHighAttrib: public Tango::Attr
{
public:
	XHighAttrib():Attr("XHigh", Tango::DEV_DOUBLE, Tango::READ) {};
	~XHighAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_XHigh(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_XHigh_allowed(ty);}
};

class XLowAttrib: public Tango::Attr
{
public:
	XLowAttrib():Attr("XLow", Tango::DEV_DOUBLE, Tango::READ) {};
	~XLowAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_XLow(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_XLow_allowed(ty);}
};

class InterlockADCPostFilterNotifiedAttrib: public Tango::Attr
{
public:
	InterlockADCPostFilterNotifiedAttrib():Attr("InterlockADCPostFilterNotified", Tango::DEV_BOOLEAN, Tango::READ) {};
	~InterlockADCPostFilterNotifiedAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_InterlockADCPostFilterNotified(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_InterlockADCPostFilterNotified_allowed(ty);}
};

class InterlockADCPreFilterNotifiedAttrib: public Tango::Attr
{
public:
	InterlockADCPreFilterNotifiedAttrib():Attr("InterlockADCPreFilterNotified", Tango::DEV_BOOLEAN, Tango::READ) {};
	~InterlockADCPreFilterNotifiedAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_InterlockADCPreFilterNotified(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_InterlockADCPreFilterNotified_allowed(ty);}
};

class InterlockAttnNotifiedAttrib: public Tango::Attr
{
public:
	InterlockAttnNotifiedAttrib():Attr("InterlockAttnNotified", Tango::DEV_BOOLEAN, Tango::READ) {};
	~InterlockAttnNotifiedAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_InterlockAttnNotified(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_InterlockAttnNotified_allowed(ty);}
};

class InterlockZNotifiedAttrib: public Tango::Attr
{
public:
	InterlockZNotifiedAttrib():Attr("InterlockZNotified", Tango::DEV_BOOLEAN, Tango::READ) {};
	~InterlockZNotifiedAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_InterlockZNotified(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_InterlockZNotified_allowed(ty);}
};

class InterlockXNotifiedAttrib: public Tango::Attr
{
public:
	InterlockXNotifiedAttrib():Attr("InterlockXNotified", Tango::DEV_BOOLEAN, Tango::READ) {};
	~InterlockXNotifiedAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_InterlockXNotified(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_InterlockXNotified_allowed(ty);}
};

class PMNotificationCounterAttrib: public Tango::Attr
{
public:
	PMNotificationCounterAttrib():Attr("PMNotificationCounter", Tango::DEV_SHORT, Tango::READ) {};
	~PMNotificationCounterAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_PMNotificationCounter(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_PMNotificationCounter_allowed(ty);}
};

class PMNotifiedAttrib: public Tango::Attr
{
public:
	PMNotifiedAttrib():Attr("PMNotified", Tango::DEV_BOOLEAN, Tango::READ) {};
	~PMNotifiedAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_PMNotified(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_PMNotified_allowed(ty);}
};

class PMOffsetAttrib: public Tango::Attr
{
public:
	PMOffsetAttrib():Attr("PMOffset", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~PMOffsetAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_PMOffset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_PMOffset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_PMOffset_allowed(ty);}
};

class ADCBufferSizeAttrib: public Tango::Attr
{
public:
	ADCBufferSizeAttrib():Attr("ADCBufferSize", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~ADCBufferSizeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_ADCBufferSize(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_ADCBufferSize(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_ADCBufferSize_allowed(ty);}
};

class ADCEnabledAttrib: public Tango::Attr
{
public:
	ADCEnabledAttrib():Attr("ADCEnabled", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~ADCEnabledAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_ADCEnabled(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_ADCEnabled(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_ADCEnabled_allowed(ty);}
};

class SumMeanSAAttrib: public Tango::Attr
{
public:
	SumMeanSAAttrib():Attr("SumMeanSA", Tango::DEV_DOUBLE, Tango::READ) {};
	~SumMeanSAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_SumMeanSA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_SumMeanSA_allowed(ty);}
};

class ZPeakPosSAAttrib: public Tango::Attr
{
public:
	ZPeakPosSAAttrib():Attr("ZPeakPosSA", Tango::DEV_DOUBLE, Tango::READ) {};
	~ZPeakPosSAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_ZPeakPosSA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_ZPeakPosSA_allowed(ty);}
};

class XPeakPosSAAttrib: public Tango::Attr
{
public:
	XPeakPosSAAttrib():Attr("XPeakPosSA", Tango::DEV_DOUBLE, Tango::READ) {};
	~XPeakPosSAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_XPeakPosSA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_XPeakPosSA_allowed(ty);}
};

class ZRMSPosSAAttrib: public Tango::Attr
{
public:
	ZRMSPosSAAttrib():Attr("ZRMSPosSA", Tango::DEV_DOUBLE, Tango::READ) {};
	~ZRMSPosSAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_ZRMSPosSA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_ZRMSPosSA_allowed(ty);}
};

class XRMSPosSAAttrib: public Tango::Attr
{
public:
	XRMSPosSAAttrib():Attr("XRMSPosSA", Tango::DEV_DOUBLE, Tango::READ) {};
	~XRMSPosSAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_XRMSPosSA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_XRMSPosSA_allowed(ty);}
};

class ZMeanPosSAAttrib: public Tango::Attr
{
public:
	ZMeanPosSAAttrib():Attr("ZMeanPosSA", Tango::DEV_DOUBLE, Tango::READ) {};
	~ZMeanPosSAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_ZMeanPosSA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_ZMeanPosSA_allowed(ty);}
};

class XMeanPosSAAttrib: public Tango::Attr
{
public:
	XMeanPosSAAttrib():Attr("XMeanPosSA", Tango::DEV_DOUBLE, Tango::READ) {};
	~XMeanPosSAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_XMeanPosSA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_XMeanPosSA_allowed(ty);}
};

class SAStatNumSamplesAttrib: public Tango::Attr
{
public:
	SAStatNumSamplesAttrib():Attr("SAStatNumSamples", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~SAStatNumSamplesAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_SAStatNumSamples(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_SAStatNumSamples(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_SAStatNumSamples_allowed(ty);}
};

class CzSAAttrib: public Tango::Attr
{
public:
	CzSAAttrib():Attr("CzSA", Tango::DEV_LONG, Tango::READ) {};
	~CzSAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_CzSA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_CzSA_allowed(ty);}
};

class CxSAAttrib: public Tango::Attr
{
public:
	CxSAAttrib():Attr("CxSA", Tango::DEV_LONG, Tango::READ) {};
	~CxSAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_CxSA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_CxSA_allowed(ty);}
};

class QuadSAAttrib: public Tango::Attr
{
public:
	QuadSAAttrib():Attr("QuadSA", Tango::DEV_DOUBLE, Tango::READ) {};
	~QuadSAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_QuadSA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_QuadSA_allowed(ty);}
};

class SumSAAttrib: public Tango::Attr
{
public:
	SumSAAttrib():Attr("SumSA", Tango::DEV_DOUBLE, Tango::READ) {};
	~SumSAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_SumSA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_SumSA_allowed(ty);}
};

class ZPosSAAttrib: public Tango::Attr
{
public:
	ZPosSAAttrib():Attr("ZPosSA", Tango::DEV_DOUBLE, Tango::READ) {};
	~ZPosSAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_ZPosSA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_ZPosSA_allowed(ty);}
};

class XPosSAAttrib: public Tango::Attr
{
public:
	XPosSAAttrib():Attr("XPosSA", Tango::DEV_DOUBLE, Tango::READ) {};
	~XPosSAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_XPosSA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_XPosSA_allowed(ty);}
};

class VdSAAttrib: public Tango::Attr
{
public:
	VdSAAttrib():Attr("VdSA", Tango::DEV_DOUBLE, Tango::READ) {};
	~VdSAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_VdSA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_VdSA_allowed(ty);}
};

class VcSAAttrib: public Tango::Attr
{
public:
	VcSAAttrib():Attr("VcSA", Tango::DEV_DOUBLE, Tango::READ) {};
	~VcSAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_VcSA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_VcSA_allowed(ty);}
};

class VbSAAttrib: public Tango::Attr
{
public:
	VbSAAttrib():Attr("VbSA", Tango::DEV_DOUBLE, Tango::READ) {};
	~VbSAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_VbSA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_VbSA_allowed(ty);}
};

class VaSAAttrib: public Tango::Attr
{
public:
	VaSAAttrib():Attr("VaSA", Tango::DEV_DOUBLE, Tango::READ) {};
	~VaSAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_VaSA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_VaSA_allowed(ty);}
};

class SAEnabledAttrib: public Tango::Attr
{
public:
	SAEnabledAttrib():Attr("SAEnabled", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~SAEnabledAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_SAEnabled(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_SAEnabled(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_SAEnabled_allowed(ty);}
};

class ExternalTriggerDelayAttrib: public Tango::Attr
{
public:
	ExternalTriggerDelayAttrib():Attr("ExternalTriggerDelay", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~ExternalTriggerDelayAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_ExternalTriggerDelay(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_ExternalTriggerDelay(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_ExternalTriggerDelay_allowed(ty);}
};

class ExternalTriggerEnabledAttrib: public Tango::Attr
{
public:
	ExternalTriggerEnabledAttrib():Attr("ExternalTriggerEnabled", Tango::DEV_BOOLEAN, Tango::READ) {};
	~ExternalTriggerEnabledAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_ExternalTriggerEnabled(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_ExternalTriggerEnabled_allowed(ty);}
};

class DDTriggerCounterAttrib: public Tango::Attr
{
public:
	DDTriggerCounterAttrib():Attr("DDTriggerCounter", Tango::DEV_LONG, Tango::READ) {};
	~DDTriggerCounterAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_DDTriggerCounter(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_DDTriggerCounter_allowed(ty);}
};

class DDBufferFrozenAttrib: public Tango::Attr
{
public:
	DDBufferFrozenAttrib():Attr("DDBufferFrozen", Tango::DEV_BOOLEAN, Tango::READ) {};
	~DDBufferFrozenAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_DDBufferFrozen(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_DDBufferFrozen_allowed(ty);}
};

class DDBufferFreezingEnabledAttrib: public Tango::Attr
{
public:
	DDBufferFreezingEnabledAttrib():Attr("DDBufferFreezingEnabled", Tango::DEV_BOOLEAN, Tango::READ) {};
	~DDBufferFreezingEnabledAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_DDBufferFreezingEnabled(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_DDBufferFreezingEnabled_allowed(ty);}
};

class DDTriggerOffsetAttrib: public Tango::Attr
{
public:
	DDTriggerOffsetAttrib():Attr("DDTriggerOffset", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~DDTriggerOffsetAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_DDTriggerOffset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_DDTriggerOffset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_DDTriggerOffset_allowed(ty);}
};

class DDDecimationFactorAttrib: public Tango::Attr
{
public:
	DDDecimationFactorAttrib():Attr("DDDecimationFactor", Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~DDDecimationFactorAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_DDDecimationFactor(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_DDDecimationFactor(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_DDDecimationFactor_allowed(ty);}
};

class DDBufferSizeAttrib: public Tango::Attr
{
public:
	DDBufferSizeAttrib():Attr("DDBufferSize", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~DDBufferSizeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_DDBufferSize(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_DDBufferSize(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_DDBufferSize_allowed(ty);}
};

class DDEnabledAttrib: public Tango::Attr
{
public:
	DDEnabledAttrib():Attr("DDEnabled", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~DDEnabledAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_DDEnabled(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Libera *>(dev))->write_DDEnabled(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_DDEnabled_allowed(ty);}
};

class LiberaModelAttrib: public Tango::Attr
{
public:
	LiberaModelAttrib():Attr("LiberaModel", Tango::DEV_USHORT, Tango::READ) {};
	~LiberaModelAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Libera *>(dev))->read_LiberaModel(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Libera *>(dev))->is_LiberaModel_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class SetRefIncoherenceCmd : public Tango::Command
{
public:
	SetRefIncoherenceCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SetRefIncoherenceCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SetRefIncoherenceCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Libera *>(dev))->is_SetRefIncoherence_allowed(any);}
};



class ReloadSystemPropertiesCmd : public Tango::Command
{
public:
	ReloadSystemPropertiesCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ReloadSystemPropertiesCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ReloadSystemPropertiesCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Libera *>(dev))->is_ReloadSystemProperties_allowed(any);}
};



class SaveDSCParametersCmd : public Tango::Command
{
public:
	SaveDSCParametersCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SaveDSCParametersCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SaveDSCParametersCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Libera *>(dev))->is_SaveDSCParameters_allowed(any);}
};



class WriteFADataCmd : public Tango::Command
{
public:
	WriteFADataCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	WriteFADataCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~WriteFADataCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Libera *>(dev))->is_WriteFAData_allowed(any);}
};



class ReadFADataCmd : public Tango::Command
{
public:
	ReadFADataCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ReadFADataCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ReadFADataCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Libera *>(dev))->is_ReadFAData_allowed(any);}
};



class SetTimeOnNextTriggerCmd : public Tango::Command
{
public:
	SetTimeOnNextTriggerCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SetTimeOnNextTriggerCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SetTimeOnNextTriggerCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Libera *>(dev))->is_SetTimeOnNextTrigger_allowed(any);}
};



class DisableADCCmd : public Tango::Command
{
public:
	DisableADCCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DisableADCCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DisableADCCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Libera *>(dev))->is_DisableADC_allowed(any);}
};



class EnableADCCmd : public Tango::Command
{
public:
	EnableADCCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	EnableADCCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~EnableADCCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Libera *>(dev))->is_EnableADC_allowed(any);}
};



class SetInterlockConfigurationCmd : public Tango::Command
{
public:
	SetInterlockConfigurationCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SetInterlockConfigurationCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SetInterlockConfigurationCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Libera *>(dev))->is_SetInterlockConfiguration_allowed(any);}
};



class ResetInterlockNotificationCmd : public Tango::Command
{
public:
	ResetInterlockNotificationCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ResetInterlockNotificationCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ResetInterlockNotificationCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Libera *>(dev))->is_ResetInterlockNotification_allowed(any);}
};



class ResetPMNotificationCmd : public Tango::Command
{
public:
	ResetPMNotificationCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ResetPMNotificationCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ResetPMNotificationCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Libera *>(dev))->is_ResetPMNotification_allowed(any);}
};



class DisableSACmd : public Tango::Command
{
public:
	DisableSACmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DisableSACmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DisableSACmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Libera *>(dev))->is_DisableSA_allowed(any);}
};



class EnableSACmd : public Tango::Command
{
public:
	EnableSACmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	EnableSACmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~EnableSACmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Libera *>(dev))->is_EnableSA_allowed(any);}
};



class DisableDDCmd : public Tango::Command
{
public:
	DisableDDCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DisableDDCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DisableDDCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Libera *>(dev))->is_DisableDD_allowed(any);}
};



class EnableDDCmd : public Tango::Command
{
public:
	EnableDDCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	EnableDDCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~EnableDDCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Libera *>(dev))->is_EnableDD_allowed(any);}
};



class DisableDDBufferFreezingCmd : public Tango::Command
{
public:
	DisableDDBufferFreezingCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DisableDDBufferFreezingCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DisableDDBufferFreezingCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Libera *>(dev))->is_DisableDDBufferFreezing_allowed(any);}
};



class EnableDDBufferFreezingCmd : public Tango::Command
{
public:
	EnableDDBufferFreezingCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	EnableDDBufferFreezingCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~EnableDDBufferFreezingCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Libera *>(dev))->is_EnableDDBufferFreezing_allowed(any);}
};



class UnfreezeDDBufferCmd : public Tango::Command
{
public:
	UnfreezeDDBufferCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	UnfreezeDDBufferCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~UnfreezeDDBufferCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Libera *>(dev))->is_UnfreezeDDBuffer_allowed(any);}
};



class GetParametersCmd : public Tango::Command
{
public:
	GetParametersCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetParametersCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetParametersCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Libera *>(dev))->is_GetParameters_allowed(any);}
};



//
// The LiberaClass singleton definition
//

class
#ifdef WIN32
	__declspec(dllexport)
#endif
	LiberaClass : public Tango::DeviceClass
{
public:
//	properties member data
/**
 *	The user defined interlock configuration. This is the configuration that should be applied on the Libera in case the device 'finds'
the Libera in its default startup configuration when it is itself starting up or executing its Init TANGO command. This configuration
can also be applied using the dedicated "SetInterlockConfiguration" expert command.
Parameters mapping:
[0] Interlock : mode - [0]: disabled, [1]: enabled, [3]: enabled with gain dependency
[1] Interlock : threshold : X low in mm
[2] Interlock : threshold : X high in mm
[3] Interlock : threshold : Z low in mm (i.e. Y low in the Libera terminology)
[4] Interlock : threshold : Z high in mm (i.e. Y high in the Libera terminology)
[5] Interlock : overflow limit (ADC threshold)
[6] Interlock : overflow duration (num of overloaded ADC samples before raising intlck)
[7] Interlock : gain limit in dBm  (intlck not active under this limit) - valid range is [-60, 0]
 */
	vector<double>	interlockConfiguration;
/**
 *	Enables/Disables  DD optional data (IxDD and QxDD)
 */
	Tango::DevBoolean	enableDDOptionalData;
/**
 *	Enables/disables SA optional Data (currently not used)
 */
	Tango::DevBoolean	enableSAOptionalData;
/**
 *	Enables/disables SA History optional data (sum history)
 */
	Tango::DevBoolean	enableSAHistoryOptionalData;
/**
 *	Enables/disables ADC optional data (currently not used)
 */
	Tango::DevBoolean	enableADCOptionalData;
/**
 *	0: TANGO_INSTITUTE (GENERIC)
1: ALBA
2: ESRF
3: ELETTRA
4: SOLEIL
 */
	Tango::DevShort	institute;

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static LiberaClass *init(const char *);
	static LiberaClass *instance();
	~LiberaClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	LiberaClass(string &);
	static LiberaClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();
	string get_cvstag();
	string get_cvsroot();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace Libera_ns

#endif // _LIBERACLASS_H
