//+=============================================================================
//
// file :         LiberaStateMachine.cpp
//
// description :  C++ source for the Libera and its alowed. 
//                method for commands and attributes
//
// project :      TANGO Device Server
//
// $Author: nleclercq $
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#include <tango.h>
#include <Libera.h>
#include <LiberaClass.h>

/*====================================================================
 *	This file contains the methods to allow commands and attributes
 * read or write execution.
 *
 * If you wand to add your own code, add it between 
 * the "End/Re-Start of Generated Code" comments.
 *
 * If you want, you can also add your own methods.
 *====================================================================
 */

namespace Libera_ns
{

//=================================================
//		Attributes Allowed Methods
//=================================================

//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ExternalTriggerEnabled_allowed
// 
// description : 	Read/Write allowed for ExternalTriggerEnabled attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_ExternalTriggerEnabled_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_DDBufferSize_allowed
// 
// description : 	Read/Write allowed for DDBufferSize attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_DDBufferSize_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_XPosDD_allowed
// 
// description : 	Read/Write allowed for XPosDD attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_XPosDD_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ZPosDD_allowed
// 
// description : 	Read/Write allowed for ZPosDD attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_ZPosDD_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_QuadDD_allowed
// 
// description : 	Read/Write allowed for QuadDD attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_QuadDD_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_SumDD_allowed
// 
// description : 	Read/Write allowed for SumDD attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_SumDD_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_VaDD_allowed
// 
// description : 	Read/Write allowed for VaDD attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_VaDD_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_VbDD_allowed
// 
// description : 	Read/Write allowed for VbDD attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_VbDD_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_VcDD_allowed
// 
// description : 	Read/Write allowed for VcDD attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_VcDD_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_VdDD_allowed
// 
// description : 	Read/Write allowed for VdDD attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_VdDD_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_DDTriggerCounter_allowed
// 
// description : 	Read/Write allowed for DDTriggerCounter attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_DDTriggerCounter_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_DDBufferFreezingEnabled_allowed
// 
// description : 	Read/Write allowed for DDBufferFreezingEnabled attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_DDBufferFreezingEnabled_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_DDBufferFrozen_allowed
// 
// description : 	Read/Write allowed for DDBufferFrozen attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_DDBufferFrozen_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_DDEnabled_allowed
// 
// description : 	Read/Write allowed for DDEnabled attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_DDEnabled_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_SAEnabled_allowed
// 
// description : 	Read/Write allowed for SAEnabled attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_SAEnabled_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ADCEnabled_allowed
// 
// description : 	Read/Write allowed for ADCEnabled attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_ADCEnabled_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ZPosSAHistory_allowed
// 
// description : 	Read/Write allowed for ZPosSAHistory attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_ZPosSAHistory_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_VaSA_allowed
// 
// description : 	Read/Write allowed for VaSA attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_VaSA_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_VbSA_allowed
// 
// description : 	Read/Write allowed for VbSA attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_VbSA_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_VcSA_allowed
// 
// description : 	Read/Write allowed for VcSA attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_VcSA_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_VdSA_allowed
// 
// description : 	Read/Write allowed for VdSA attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_VdSA_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_XPosSA_allowed
// 
// description : 	Read/Write allowed for XPosSA attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_XPosSA_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ZPosSA_allowed
// 
// description : 	Read/Write allowed for ZPosSA attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_ZPosSA_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_SumSA_allowed
// 
// description : 	Read/Write allowed for SumSA attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_SumSA_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_QuadSA_allowed
// 
// description : 	Read/Write allowed for QuadSA attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_QuadSA_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_XPosPM_allowed
// 
// description : 	Read/Write allowed for XPosPM attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_XPosPM_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ZPosPM_allowed
// 
// description : 	Read/Write allowed for ZPosPM attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_ZPosPM_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_QuadPM_allowed
// 
// description : 	Read/Write allowed for QuadPM attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_QuadPM_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_SumPM_allowed
// 
// description : 	Read/Write allowed for SumPM attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_SumPM_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_VaPM_allowed
// 
// description : 	Read/Write allowed for VaPM attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_VaPM_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_VbPM_allowed
// 
// description : 	Read/Write allowed for VbPM attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_VbPM_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_VcPM_allowed
// 
// description : 	Read/Write allowed for VcPM attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_VcPM_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_VdPM_allowed
// 
// description : 	Read/Write allowed for VdPM attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_VdPM_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_PMNotified_allowed
// 
// description : 	Read/Write allowed for PMNotified attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_PMNotified_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_InterlockXNotified_allowed
// 
// description : 	Read/Write allowed for InterlockXNotified attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_InterlockXNotified_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_InterlockZNotified_allowed
// 
// description : 	Read/Write allowed for InterlockZNotified attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_InterlockZNotified_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_InterlockAttnNotified_allowed
// 
// description : 	Read/Write allowed for InterlockAttnNotified attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_InterlockAttnNotified_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_InterlockADCPreFilterNotified_allowed
// 
// description : 	Read/Write allowed for InterlockADCPreFilterNotified attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_InterlockADCPreFilterNotified_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_InterlockADCPostFilterNotified_allowed
// 
// description : 	Read/Write allowed for InterlockADCPostFilterNotified attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_InterlockADCPostFilterNotified_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_DDTriggerOffset_allowed
// 
// description : 	Read/Write allowed for DDTriggerOffset attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_DDTriggerOffset_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_XLow_allowed
// 
// description : 	Read/Write allowed for XLow attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_XLow_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_XHigh_allowed
// 
// description : 	Read/Write allowed for XHigh attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_XHigh_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ZLow_allowed
// 
// description : 	Read/Write allowed for ZLow attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_ZLow_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ZHigh_allowed
// 
// description : 	Read/Write allowed for ZHigh attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_ZHigh_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_AutoSwitchingEnabled_allowed
// 
// description : 	Read/Write allowed for AutoSwitchingEnabled attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_AutoSwitchingEnabled_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_InterlockConfiguration_allowed
// 
// description : 	Read/Write allowed for InterlockConfiguration attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_InterlockConfiguration_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_AGCEnabled_allowed
// 
// description : 	Read/Write allowed for AGCEnabled attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_AGCEnabled_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_DSCMode_allowed
// 
// description : 	Read/Write allowed for DSCMode attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_DSCMode_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_Gain_allowed
// 
// description : 	Read/Write allowed for Gain attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_Gain_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_XPosSAHistory_allowed
// 
// description : 	Read/Write allowed for XPosSAHistory attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_XPosSAHistory_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_SAStatNumSamples_allowed
// 
// description : 	Read/Write allowed for SAStatNumSamples attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_SAStatNumSamples_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_XRMSPosSA_allowed
// 
// description : 	Read/Write allowed for XRMSPosSA attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_XRMSPosSA_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ZRMSPosSA_allowed
// 
// description : 	Read/Write allowed for ZRMSPosSA attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_ZRMSPosSA_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ADCBufferSize_allowed
// 
// description : 	Read/Write allowed for ADCBufferSize attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_ADCBufferSize_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ADCChannelA_allowed
// 
// description : 	Read/Write allowed for ADCChannelA attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_ADCChannelA_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ADCChannelB_allowed
// 
// description : 	Read/Write allowed for ADCChannelB attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_ADCChannelB_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ADCChannelC_allowed
// 
// description : 	Read/Write allowed for ADCChannelC attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_ADCChannelC_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ADCChannelD_allowed
// 
// description : 	Read/Write allowed for ADCChannelD attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_ADCChannelD_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_MachineTime_allowed
// 
// description : 	Read/Write allowed for MachineTime attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_MachineTime_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_SystemTime_allowed
// 
// description : 	Read/Write allowed for SystemTime attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_SystemTime_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_TimePhase_allowed
// 
// description : 	Read/Write allowed for TimePhase attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_TimePhase_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_HWTemperature_allowed
// 
// description : 	Read/Write allowed for HWTemperature attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_HWTemperature_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_Fan1Speed_allowed
// 
// description : 	Read/Write allowed for Fan1Speed attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_Fan1Speed_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_Fan2Speed_allowed
// 
// description : 	Read/Write allowed for Fan2Speed attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_Fan2Speed_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_SCPLLStatus_allowed
// 
// description : 	Read/Write allowed for SCPLLStatus attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_SCPLLStatus_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_MCPLLStatus_allowed
// 
// description : 	Read/Write allowed for MCPLLStatus attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_MCPLLStatus_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_XMeanPosSA_allowed
// 
// description : 	Read/Write allowed for XMeanPosSA attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_XMeanPosSA_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ZMeanPosSA_allowed
// 
// description : 	Read/Write allowed for ZMeanPosSA attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_ZMeanPosSA_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_XPeakPosSA_allowed
// 
// description : 	Read/Write allowed for XPeakPosSA attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_XPeakPosSA_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ZPeakPosSA_allowed
// 
// description : 	Read/Write allowed for ZPeakPosSA attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_ZPeakPosSA_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}

//+----------------------------------------------------------------------------
//
// method : 		Libera::is_CxSA_allowed
// 
// description : 	Read/Write allowed for CxSA attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_CxSA_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_CzSA_allowed
// 
// description : 	Read/Write allowed for CzSA attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_CzSA_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_PMNotificationCounter_allowed
// 
// description : 	Read/Write allowed for PMNotificationCounter attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_PMNotificationCounter_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_UserData_allowed
// 
// description : 	Read/Write allowed for UserData attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_UserData_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_CpuUsage_allowed
// 
// description : 	Read/Write allowed for CpuUsage attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_CpuUsage_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_FreeMemory_allowed
// 
// description : 	Read/Write allowed for FreeMemory attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_FreeMemory_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_RamFsUsage_allowed
// 
// description : 	Read/Write allowed for RamFsUsage attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_RamFsUsage_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_UpTime_allowed
// 
// description : 	Read/Write allowed for UpTime attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_UpTime_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_MAFLength_allowed
// 
// description : 	Read/Write allowed for MAFLength attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_MAFLength_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_MAFDelay_allowed
// 
// description : 	Read/Write allowed for MAFDelay attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_MAFDelay_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ExternalSwitching_allowed
// 
// description : 	Read/Write allowed for ExternalSwitching attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_ExternalSwitching_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_SwitchingDelay_allowed
// 
// description : 	Read/Write allowed for SwitchingDelay attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_SwitchingDelay_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_CompensateTune_allowed
// 
// description : 	Read/Write allowed for CompensateTune attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_CompensateTune_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_OffsetTune_allowed
// 
// description : 	Read/Write allowed for OffsetTune attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_OffsetTune_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ExternalTriggerDelay_allowed
// 
// description : 	Read/Write allowed for ExternalTriggerDelay attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_ExternalTriggerDelay_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_PMOffset_allowed
// 
// description : 	Read/Write allowed for PMOffset attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_PMOffset_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_Incoherence_allowed
// 
// description : 	Read/Write allowed for Incoherence attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_Incoherence_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_RefIncoherence_allowed
// 
// description : 	Read/Write allowed for RefIncoherence attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_RefIncoherence_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_MaxIncoherence_allowed
// 
// description : 	Read/Write allowed for MaxIncoherence attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_MaxIncoherence_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_MaxIncoherenceDrift_allowed
// 
// description : 	Read/Write allowed for MaxIncoherenceDrift attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_MaxIncoherenceDrift_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_SumMeanSA_allowed
// 
// description : 	Read/Write allowed for SumMeanSA attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_SumMeanSA_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_IaDD_allowed
// 
// description : 	Read/Write allowed for IaDD attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_IaDD_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_IbDD_allowed
// 
// description : 	Read/Write allowed for IbDD attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_IbDD_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_IcDD_allowed
// 
// description : 	Read/Write allowed for IcDD attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_IcDD_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_IdDD_allowed
// 
// description : 	Read/Write allowed for IdDD attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_IdDD_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_QaDD_allowed
// 
// description : 	Read/Write allowed for QaDD attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_QaDD_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_QbDD_allowed
// 
// description : 	Read/Write allowed for QbDD attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_QbDD_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_QcDD_allowed
// 
// description : 	Read/Write allowed for QcDD attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_QcDD_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_QdDD_allowed
// 
// description : 	Read/Write allowed for QdDD attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_QdDD_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_SumSAHistory_allowed
// 
// description : 	Read/Write allowed for SumSAHistory attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_SumSAHistory_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_logs_allowed
// 
// description : 	Read/Write allowed for logs attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_logs_allowed(Tango::AttReqType type)
{
		//	End of Generated Code

		//	Re-Start of Generated Code
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_HasMAFSupport_allowed
// 
// description : 	Read/Write allowed for HasMAFSupport attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_HasMAFSupport_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_UseLiberaSAData_allowed
// 
// description : 	Read/Write allowed for UseLiberaSAData attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_UseLiberaSAData_allowed(Tango::AttReqType type)
{
		//	End of Generated Code

		//	Re-Start of Generated Code
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_LiberaModel_allowed
// 
// description : 	Read/Write allowed for LiberaModel attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_LiberaModel_allowed(Tango::AttReqType type)
{
		//	End of Generated Code

		//	Re-Start of Generated Code
	return true;
}

//=================================================
//		Commands Allowed Methods
//=================================================

//+----------------------------------------------------------------------------
//
// method : 		Libera::is_GetParameters_allowed
// 
// description : 	Execution allowed for GetParameters command.
//
//-----------------------------------------------------------------------------
bool Libera::is_GetParameters_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_EnableDD_allowed
// 
// description : 	Execution allowed for EnableDD command.
//
//-----------------------------------------------------------------------------
bool Libera::is_EnableDD_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_DisableDD_allowed
// 
// description : 	Execution allowed for DisableDD command.
//
//-----------------------------------------------------------------------------
bool Libera::is_DisableDD_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_EnableSA_allowed
// 
// description : 	Execution allowed for EnableSA command.
//
//-----------------------------------------------------------------------------
bool Libera::is_EnableSA_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_DisableSA_allowed
// 
// description : 	Execution allowed for DisableSA command.
//
//-----------------------------------------------------------------------------
bool Libera::is_DisableSA_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_UnfreezeDDBuffer_allowed
// 
// description : 	Execution allowed for UnfreezeDDBuffer command.
//
//-----------------------------------------------------------------------------
bool Libera::is_UnfreezeDDBuffer_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_EnableDDBufferFreezing_allowed
// 
// description : 	Execution allowed for EnableDDBufferFreezing command.
//
//-----------------------------------------------------------------------------
bool Libera::is_EnableDDBufferFreezing_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_DisableDDBufferFreezing_allowed
// 
// description : 	Execution allowed for DisableDDBufferFreezing command.
//
//-----------------------------------------------------------------------------
bool Libera::is_DisableDDBufferFreezing_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ResetPMNotification_allowed
// 
// description : 	Execution allowed for ResetPMNotification command.
//
//-----------------------------------------------------------------------------
bool Libera::is_ResetPMNotification_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ResetInterlockNotification_allowed
// 
// description : 	Execution allowed for ResetInterlockNotification command.
//
//-----------------------------------------------------------------------------
bool Libera::is_ResetInterlockNotification_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_Switches_allowed
// 
// description : 	Read/Write allowed for Switches attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_Switches_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_DDDecimationFactor_allowed
// 
// description : 	Read/Write allowed for DDDecimationFactor attribute.
//
//-----------------------------------------------------------------------------
bool Libera::is_DDDecimationFactor_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_SetInterlockConfiguration_allowed
// 
// description : 	Execution allowed for SetInterlockConfiguration command.
//
//-----------------------------------------------------------------------------
bool Libera::is_SetInterlockConfiguration_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_EnableADC_allowed
// 
// description : 	Execution allowed for EnableADC command.
//
//-----------------------------------------------------------------------------
bool Libera::is_EnableADC_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_DisableADC_allowed
// 
// description : 	Execution allowed for DisableADC command.
//
//-----------------------------------------------------------------------------
bool Libera::is_DisableADC_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_SetTimeOnNextTrigger_allowed
// 
// description : 	Execution allowed for SetTimeOnNextTrigger command.
//
//-----------------------------------------------------------------------------
bool Libera::is_SetTimeOnNextTrigger_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ReadFAData_allowed
// 
// description : 	Execution allowed for ReadFAData command.
//
//-----------------------------------------------------------------------------
bool Libera::is_ReadFAData_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_WriteFAData_allowed
// 
// description : 	Execution allowed for WriteFAData command.
//
//-----------------------------------------------------------------------------
bool Libera::is_WriteFAData_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_SaveDSCParameters_allowed
// 
// description : 	Execution allowed for SaveDSCParameters command.
//
//-----------------------------------------------------------------------------
bool Libera::is_SaveDSCParameters_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_ReloadSystemProperties_allowed
// 
// description : 	Execution allowed for ReloadSystemProperties command.
//
//-----------------------------------------------------------------------------
bool Libera::is_ReloadSystemProperties_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Libera::is_SetRefIncoherence_allowed
// 
// description : 	Execution allowed for SetRefIncoherence command.
//
//-----------------------------------------------------------------------------
bool Libera::is_SetRefIncoherence_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::UNKNOWN	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}

}	// namespace Libera_ns
